<?php
/**
* @version $Id: admin.groupjive.php
* @package Joomla!
* @subpackage GroupJive
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
* @Joomla! is Free Software
* @author Joshua Holmes
* @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
*/


defined( '_VALID_MOS' ) or defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

// include CB framework
global $mainframe;

if ( defined( 'JPATH_ADMINISTRATOR' ) ) {
	$foundation			= JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.foundation.php';
	$pluginclass		= JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.class.php';
	$comprofilerclass	= JPATH_ADMINISTRATOR . '/components/com_comprofiler/comprofiler.class.php';
} else {
	$foundation			= $mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/plugin.foundation.php';
	$pluginclass		= $mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/plugin.class.php';
	$comprofilerclass	= $mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/comprofiler.class.php';
}

include_once( $foundation );
include_once( $pluginclass );
include_once( $comprofilerclass );

cbimport( 'cb.database' );

global $_PLUGINS, $_CB_framework, $ueConfig;

$_CB_framework->_ui = 2;

$_PLUGINS->loadPluginGroup('user');

if (!$_CB_framework->check_acl( 'canEditAllContent', $_CB_framework->myUserType() )) {
	$_CB_framework->redirect('index2.php', _NOT_AUTH);
}

	//	var_dump($_REQUEST);

if (!defined('GJBASEPATH'))		{define( 'GJBASEPATH', dirname(__FILE__) );}
if (!defined('GJADMINPATH'))	{define('GJADMINPATH', $_CB_framework->getCfg( 'absolute_path' ). "/administrator");}
if (!defined('JPATH'))			{define ('JPATH', $_CB_framework->getCfg('absolute_path'));}

global $gjConfig;
$configfile			=	GJADMINPATH."/components/com_groupjive/gj_config.php";
require_once( $configfile );

require_once(JPATH."/components/com_groupjive/helpers.php");

define('GJPATH', 'components/com_groupjive');
define('CBPATH', GJADMINPATH.'/components/com_comprofiler');

require_once( $mainframe->getPath( 'admin_html' ) );
require_once( $mainframe->getPath( 'class' ) );

if (file_exists(CBPATH.'/imgToolbox.class.php')){
	require_once(CBPATH."/imgToolbox.class.php");
} else {
	die( 'Community Builder is not installed. These components is required for GroupJive to function!' );
}

// include CB / CBE config
if (file_exists(CBPATH.'/ue_config.php')) {
	require_once(CBPATH.'/ue_config.php');
} elseif (file_exists(CBPATH.'/enhanced_admin/enhanced_config.php')) {
	require_once(CBPATH.'/enhanced_admin/enhanced_config.php');
}

$UElanguagePath		=	$_CB_framework->getCfg( 'absolute_path' ) . '/components/com_comprofiler/plugin/language';
$UElanguage			=	$_CB_framework->getCfg( 'lang' );

if ( ! file_exists( $UElanguagePath . '/' . $UElanguage . '/' . $UElanguage . '.php' ) ) {
	$UElanguage		=	'default_language';
}

include_once( $UElanguagePath . '/' . $UElanguage . '/' . $UElanguage . '.php' );

if (file_exists('../'.GJPATH.'/language/'.$UElanguage.'/'.$UElanguage.'.php')) {
	include_once('../'.GJPATH.'/language/'.$UElanguage.'/'.$UElanguage.'.php');
} else {
	require_once('../'.GJPATH.'/language/english/english.php');
}

define('ONPAGE', 10); //number of groups on page

$exgroup	= intval( cbGetParam( $_REQUEST, 'groupid',0));
$act		= cbGetParam($_REQUEST,'act','');

// do we really need this? ^^ $cid
$cid		=	cbGetParam( $_REQUEST, 'cid', array( 0 ) );
$uid 		=	cbGetParam( $_REQUEST, 'uid', array(0) );

if ( ! is_array( $cid )) {
	$cid	=	array ( (int) $cid );
}

switch($task) {
	case 'delete':
		deleteGroup($exgroup);
		break;

	case 'settings':
		editoptions($option);
		break;

	case 'saveconfig':
		saveconfig($option);
		break;

	case 'categoriesmanager':
		listcategory($option);
		break;

	case 'groupsmanager':
		listGroup($option);
		break;

	// members
	case 'membersmanager':
		membersManager($option, $task);
		break;

	case 'membergroupsmanager':
		membergroupsmanager($option, $cid);
		break;

	//members
	case 'invitemembers':
		$_CB_framework->redirect( 'index2.php?option=com_groupjive&amp;task=membersmanager','Sorry, this feature has not yet been implemented. We\'re working on it.' );
		break;

	case 'deletemembers':
	case 'addmembers':
		addMembers($option, $task, $cid);
		break;

	case 'savedeletemembers':
		saveDeleteMembers($uid, $cid);
		break;

	case 'saveaddmembers':
		saveAddMembers($uid, $cid);
		break;

	// options
	case "saveoptions":
		saveoptions( $option );
		break;

	//category
	case "editcategory":
		editcategory($option, $cid);
		break;

	case "savecategory":
		savecategory( $option );
		break;

	case "delcategory":
		delcategory($option, $cid);
		break;

	case "newcategory" :
		$id = '';
		editcategory( $option, $cid);
		break;

	case "publishcat" :
		publish($option, '1', $cid, "cat");
		break;

	case "unpublishcat" :
		publish($option, '0', $cid, "cat");
		break;

	case "orderup":
		ordercategory( $cid[0], -1, $option );
		break;

	case "orderdown":
		ordercategory( $cid[0], 1, $option );
		break;

	//group
	case "editgroup":
		editgroup($option, $cid);
		break;

	case "savegroup":
		savegroup( $option );
		break;

	case "delgroup";
		delgroup($option, $cid);
		break;

	case "newgroup" :
		$id = '';
		editgroup( $option, $cid);
		break;

	case "publishgroup" :
		publish($option, '1', $cid, "group");
		break;

	case "unpublishgroup" :
		publish($option, '0', $cid, "group");
		break;

	case 'accesspublic':
		accessMenu( intval( $cid[0] ), 0, $option );
		break;

	case 'accessregistered':
		accessMenu( intval( $cid[0] ), 1, $option );
		break;

	case 'accessspecial':
		accessMenu( intval( $cid[0] ), 2, $option );
		break;

	case 'updateforum':
		updateForum();
		break;

	case 'updateevents':
		updateEvents();
		break;

	case 'readme':
		$readme = cbGetParam($_REQUEST, 'readme', 'readme.txt');
		HTML_wg::showOverview('readme', $readme);
		break;

	default:
		HTML_wg::showOverview();
		break;
}

// new

function editoptions($option) {
	global $_CB_database;

	$row = new groupJiveOptions($_CB_database);
	$row -> load(1);
	HTML_wg::editOptions($option, $row);
}

/**
* @param  string   $sql        SQL with ordering As value and 'name field' AS text
* @param  int      $chop       The length of the truncated headline
* @param  boolean  $translate  translate to CB language
* @return array                of makeOption
* @access private
*/
function _gjGetOrderingList( $sql, $chop = 30, $translate = true ) {
	global $_CB_database;

	$order				=	array();
	$_CB_database->setQuery( $sql );
	if ( false === ( $orders = $_CB_database->loadObjectList() ) ) {
		if ( $_CB_database->getErrorNum() ) {
			echo $_CB_database->stderr();
			return false;
		} else {
			$order[]	=	groupjiveHTML::makeOption( 1, 'first' );
			return $order;
		}
	}
	$order[]			=	groupjiveHTML::makeOption( 0, '0 ' . 'first' );
	for ( $i=0, $n = count( $orders ); $i < $n; $i++ ) {
		if ( $translate ) {
			$text		=	getLangDefinition( $orders[$i]->text );
		} else {
			$text		=	$orders[$i]->text;
		}
        if ( strlen( $text ) > $chop ) {
        	$text		=	substr( $text, 0, $chop ) . '...';
        }

		$order[]		=	groupjiveHTML::makeOption( $orders[$i]->value, $orders[$i]->value . ' (' . $text . ')' );
	}
	if ( isset( $orders[$i - 1] ) ) {
		$order[]		=	groupjiveHTML::makeOption( $orders[$i - 1]->value + 1, ( $orders[$i - 1]->value + 1 ) . ' ' . 'last' );
	}
	return $order;
}

function saveoptions($option) {
	global $_CB_database, $_CB_framework, $gjConfig;
	$row = new groupJiveOptions($_CB_database);

	// bind it to the table
	if (!$row -> bind($_POST)) {
		echo "<script> alert('"
			.$row -> getError()
			."'); window.history.go(-1); </script>\n";
		exit();
	}

	// store it in the db
	if (!$row -> store()) {
		echo "<script> alert('"
			.$row -> getError()
			."'); window.history.go(-1); </script>\n";
		exit();
	}
	//insert default logo
	if($_FILES['nophoto_logo']['size'] > 0) {
		$logo_def = create_picture($_FILES['nophoto_logo'],
					"groupjive_default", JPATH."/images/com_groupjive/");

		$q = "UPDATE #__gj_options SET nophoto_logo='".$logo_def."'";
		$_CB_database->setQuery( $q );

		if( $_CB_database->query() === false )
			die( mysql_error() );
	}
	$_CB_framework->redirect("index2.php?option=com_groupjive&task=settings", "Settings saved");
}

function listcategory($option) {
	global $_CB_database,$_CB_framework;

	// get list limit
	$listlimit = $_CB_framework->getCfg( 'list_limit' );
	if (!isset($listlimit) || !$listlimit) {
		$limit = 10;
	}
	else {
		$limit = $listlimit;
	}

	$limit = $_CB_framework->getUserStateFromRequest( "viewlistlimit", 'limit', $limit );
	$limitstart = $_CB_framework->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );

	$sql = "SELECT COUNT(*)"
		. "\nFROM #__gj_grcategory a"
		. "\nLEFT JOIN #__groups b"
		. "\nON a.access = b.id"
		. "\nLEFT JOIN #__users c"
		. "\nON a.admin = c.id";
	$_CB_database->setQuery($sql);
	$total = $_CB_database->loadResult();


	outputCbJs(0);
	cbImport('cb.pagination');
	$pageNav = new cbPageNav( $total, $limitstart, $limit  );

	$sql = "SELECT a.*, b.name AS groupname, c.username AS adminname "
		. "FROM #__gj_grcategory a "
		. "LEFT JOIN #__groups b "
		. "ON a.access = b.id "
		. "LEFT JOIN #__users c "
		. "ON a.admin = c.id "
		. "ORDER BY ordering"
		. "\nLIMIT " . (int) $pageNav->limitstart . ", " . (int) $pageNav->limit;

	$_CB_database->setQuery($sql);
	$rows = $_CB_database->loadObjectList();
	if ($_CB_database->getErrorNum()) {
		echo $_CB_database->stderr();
		return false;
	}
	HTML_wg::listCategory($option, $rows, $pageNav);
}

function editcategory($option, $uid) {
	global $_CB_database;

	$row = new groupJiveCategory($_CB_database);
	if($uid){
		$row -> load($uid[0]);
	}

	// build the html select list for the category access
	//$lists['access'] = mosAdminMenus::Access( $row );

	HTML_wg::editCategory($option, $row, $lists);
}

function savecategory( $option ) {
	global $_CB_database, $_CB_framework;
	$row = new groupJiveCategory($_CB_database);
	if (empty($_REQUEST['id'])) {
		$row->ordering = 9999;
	}

	// bind it to the table
	if (!$row -> bind($_POST)) {
		echo "<script> alert('"
		.$row -> getError()
		."'); window.history.go(-1); </script>\n";
	exit();
	}

	// store it in the db
	if (!$row -> store()) {
		echo "<script> alert('"
		.$row -> getError()
		."'); window.history.go(-1); </script>\n";
		exit();
	}

	//inserting category image
	if($_FILES['image_file_cat']['size'] > 0) {
		if( !empty($_REQUEST['id'] ))
			$cat_id = $_REQUEST['id'];
		else
			$cat_id=mysql_insert_id();

		$logo = create_picture($_FILES['image_file_cat'],
				"cat_".$cat_id, JPATH."/images/com_groupjive/");

		$q = "UPDATE #__gj_grcategory SET cat_image='".$logo."' "
			. "WHERE id=$cat_id";
		$_CB_database->setQuery( $q );
		if( $_CB_database->query() === false ) die( mysql_error() );
	}
	$row->updateOrder();
	$_CB_framework->redirect("index2.php?option=$option&task=categoriesmanager", "Category saved");
}

function delcategory($option, $cid) {
	global $_CB_database, $_CB_framework;
	if (!is_array($cid) || count($cid) < 1) {
		echo "<script> alert('Select an item to delete'); "
			. "window.history.go(-1);</script>\n";
		exit();
	}

	if (count($cid)) {
		$ids = implode(',', $cid);
		$sql = "DELETE FROM #__gj_grcategory \nWHERE id IN ($ids)";
		$_CB_database->setQuery($sql);
	}
	if (!$_CB_database->query()) {
		echo "<script> alert('"
			.$_CB_database->getErrorMsg()
			."'); window.history.go(-1); </script>\n";
	}

	$_CB_framework->redirect("index2.php?option=$option&task=categoriesmanager", "Categories deleted");
}

function ordercategory( $uid, $inc, $option ) {
	global $_CB_database, $_CB_framework;

	$row = new groupJiveCategory( $_CB_database );
	$row->load( $uid );
	$row->move( $inc );
	$_CB_framework->redirect( "index2.php?option=$option&task=categoriesmanager" );
}
// new groups
function listGroup($option) {
	global $_CB_database, $_CB_framework;

	// get list limit
	$listlimit = $_CB_framework->getCfg( 'list_limit' );
	if (!isset($listlimit) || !$listlimit) {
		$limit = 10;
	}
	else {
		$limit = $listlimit;
	}

	$limit = $_CB_framework->getUserStateFromRequest( "viewlistlimit", 'limit', $limit );
	$limitstart = $_CB_framework->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );

	$sql = "SELECT COUNT(*)"
		. "\nFROM #__gj_groups a"
		. "\nINNER JOIN #__gj_grcategory b"
		. "\nON a.category = b.id";
	$_CB_database->setQuery($sql);
	$total = $_CB_database->loadResult();

	outputCbJs(2);
	cbImport('cb.pagination');
	$pageNav = new cbPageNav( $total, $limitstart, $limit  );

	$sql = "SELECT a.*, b.catname, b.access "
		. "FROM #__gj_groups a "
		. "INNER JOIN #__gj_grcategory b "
		. "ON a.category = b.id ORDER BY name"
		. "\nLIMIT " . (int) $pageNav->limitstart . ", " . (int) $pageNav->limit;
	$_CB_database->setQuery($sql);
	$rows = $_CB_database->loadObjectList();
	if ($_CB_database->getErrorNum()) {
		echo $_CB_database->stderr();
		return false;
	}
	HTML_wg::listGroup($option, $rows, $pageNav);
}

function editgroup($option, $uid) {
	global $_CB_database;

	// check if categories are available
	$sql = "SELECT COUNT(*) FROM #__gj_grcategory WHERE published = 1";
	$_CB_database->setQuery($sql);
	$cats = $_CB_database->loadResult();
	if ($_CB_database->getErrorNum()) {
		echo $_CB_database->stderr();
		return false;
	}
	if ($cats == 0) {
		HTML_wg::errorpage(GJ_NO_CAT_AVAILABLE);
		return false;
	}


	$row = new groupJiveGroup($_CB_database);
	if($uid){
		$row -> load($uid[0]);
	}

	HTML_wg::editGroup($option, $row);
}

function savegroup( $option ) {
	global $_CB_database, $_CB_framework, $gjConfig, $_PLUGINS;
	$row = new groupJiveGroup($_CB_database);

	$admin_id = $_REQUEST['user_id'];
	$q = "SELECT username FROM #__users WHERE id = $admin_id";

	$_CB_database->setQuery( $q );
	$name = $_CB_database->loadResult();

	$_POST['creator'] = $name;
	if(empty($_REQUEST['id'])) {
		$_POST['date_s'] = date("Y-m-d H:i:s");
	}
	// bind it to the table
	if (!$row -> bind($_POST)) {
		echo "<script> alert('"
			.$row -> getError()
			."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (!$row->check()) {
		echo "<script> alert('"
			.$row -> getError()
			."'); window.history.go(-1); </script>\n";
		exit();
	}

	// store it in the db
	if (!$row -> store()) {
		echo "<script> alert('"
			.$row -> getError()
			."'); window.history.go(-1); </script>\n";
		exit();
	}

	if( !empty($_REQUEST['id'] ))
		$g_id = $_REQUEST['id'];
	else
		$g_id=mysql_insert_id();

	if($_FILES['image_file']['size'] > 0) {
		$logo = create_picture($_FILES['image_file'], $g_id, JPATH."/images/com_groupjive/");

		$q = "UPDATE #__gj_groups SET logo='".$logo."' WHERE id=$g_id ";
		$_CB_database->setQuery( $q );
		if( $_CB_database->query() === false ) die( mysql_error() );
	}


	$group['id'] 			= $g_id;
	$group['name'] 			= escapeString($_POST['name']);
	$group['creatorname'] 	= $name;
	$group['creatorid'] 	= $admin_id;

	$_PLUGINS->trigger( 'gj_onAfterCreateGroup', array( &$group, true ) );


/*
	//EventList integration, create an unpublished category for each group
	if($res[0]->eventlist) {
	  $_CB_database->setQuery("SELECT category_id FROM #__gj_eventlist WHERE group_id=$g_id");
	  $cat_id_eventlist = $_CB_database->loadResult();
	  if(!$cat_id_eventlist) {
	    $query = "INSERT INTO #__eventlist_categories "
			. "\n(catname, catdescription, image, publishedcat,"
			. "\nchecked_out, checked_out_time, access, ordering)"
			. "\nVALUES ('".$_CB_database->getEscaped($row->name)."', '"
			. $_CB_database->getEscaped($row->descr)."', '', '0', '0', '', '0', '')";
	    $_CB_database->setQuery($query);
	    $_CB_database->query();

	    $lastid_el=$_CB_database->insertid();
	    $query="INSERT INTO #__gj_eventlist (group_id, category_id) "
	      . "VALUES ($g_id, $lastid_el)";
	    $_CB_database->setQuery($query);
	    $_CB_database->query();
	  } else {
				$sql = "UPDATE #__eventlist_categories a"
					. "\nINNER JOIN #__gj_eventlist b"
					. "\nON a.id = b.category_id"
					. "\nSET a.catname = '".$_CB_database->getEscaped($row->name)."',"
					. "\na.catdescription = '".$_CB_database->getEscaped($row->descr)."'";

				$_CB_database->setQuery($sql);
				if (!$result=$_CB_database->query()) {
					echo $_CB_database->stderr();
					return;
				}
		}
	}
*/

	$q = "INSERT IGNORE INTO #__gj_users "
		. "\n(id_user, id_group, date, status)"
		. "\nVALUES"
		. "\n({$row->user_id}, {$row->id}, now(), 'active');";

	$_CB_database->setQuery( $q );

	if( $_CB_database->query() === false )
		die( mysql_error() );
	$_CB_framework->redirect("index2.php?option=$option&task=groupsmanager", "Group saved");
}

function delgroup($option, $cid) {
	global $_CB_database, $_CB_framework;
	if (!is_array($cid) || count($cid) < 1) {
		echo "<script> alert('Select an item to delete'); "
			. "window.history.go(-1);</script>\n";
		exit();
	}

	$g = new groupJiveGroup($_CB_database);
	foreach($cid as $group){
		$g->load($group);

		//delete images
		foreach(glob(JPATH."/images/com_groupjive/".$group.".*") as $fn) {
			if (file_exists($fn)) {
				unlink($fn);
			}
		}
		foreach(glob(JPATH."/images/com_groupjive/tn".$group.".*") as $fn) {
			if (file_exists($fn)) {
				unlink($fn);
			}
		}

		// Don't leave anything orphaned
		if ($g->deleteAll()) {
			$state[$group] = 1; //sucess
		} else {
			$state[$group] = "Error: ".$g->getError;
		}
	}

	//check for errors and report if
	foreach($state as $e){
		if ($e != 1) {
			echo "<script> alert('"
				.$e
				."'); window.history.go(-1); </script>\n";
		}
	}

	$_CB_framework->redirect("index2.php?option=$option&task=groupsmanager", "Group(s) deleted");
}


function publish( $option, $publish=1 ,$cid, $grouporcat ) {
	global $_CB_database, $_CB_framework;

	if (!is_array( $cid ) || count( $cid ) < 1) {
		$action = $publish ? 'publish' : 'unpublish';
		echo "<script> alert('Select an item to $action'); "
			. "window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );

	switch ($grouporcat) {
		case "group":
			$sql = "UPDATE #__gj_groups SET active='$publish'"
				. "\nWHERE id IN ($cids)";
			$url = "index2.php?option=$option&task=groupsmanager";
			break;
		case "cat":
			$sql = "UPDATE #__gj_grcategory SET published=$publish"
				. "\nWHERE id IN ($cids)";
			$url = "index2.php?option=$option&task=categoriesmanager";
			break;
		default:
			echo "<script> alert('Error while publishing - this "
				. "should not appear!!!'); window.history.go(-1); </script>\n";
			exit();
		break;
	}

	$_CB_database->setQuery( $sql	);
	if (!$_CB_database->query()) {
		echo "<script> alert('".$_CB_database->getErrorMsg()."'); "
			. "window.history.go(-1); </script>\n";
		exit();
	}

	$_CB_framework->redirect( $url );
}

function create_picture($file, $name, $path) {
	global $_CB_database, $gjConfig, $ueConfig;

	require_once(CBPATH."/imgToolbox.class.php");

	foreach(glob(JPATH."/images/com_groupjive/".$name	.".*") as $fn) {
		if (file_exists($fn)) {
			unlink($fn);
		}
	}

	if( $file['size'] > 0 ) {
		$imgToolBox 					= new imgToolBox();
		$imgToolBox->_conversiontype	= $ueConfig['conversiontype'];
		$imgToolBox->_IM_path 			= $ueConfig['im_path'];
		$imgToolBox->_NETPBM_path 		= $ueConfig['netpbm_path'];
		$imgToolBox->_maxsize 			= $gjConfig['logosize'];
		$imgToolBox->_maxwidth 			= $gjConfig['logowidth'];
		$imgToolBox->_maxheight 		= $gjConfig['logoheight'];
		$imgToolBox->_debug 			= 0;

		if( ! $newFileName = $imgToolBox->processImage( $file, $name, $path, 0, 0, 1 ) ) {
			echo "The following error occured while processing "
				. "your request:<br/>\n";
			echo $imgToolBox->_errMSG . "<br/>\n";
			exit();
		}
		return $newFileName;
	}
}


/**
 * @param integer The id of the content item
 * @param integer The new access level
 * @param string The URL option
 */
function accessMenu( $uid, $access, $option ) {
	global $_CB_database, $_CB_framework;

	$row = new groupJiveCategory( $_CB_database );
	$row->load( (int)$uid );
	$row->access = $access;

	if ( !$row->check() ) {
		return $row->getError();
	}
	if ( !$row->store() ) {
		return $row->getError();
	}

	// clean any existing cache files
	mosCache::cleanCache( 'com_groupjive' );
	$_CB_framework->redirect( 'index2.php?option='. $option . '&amp;task=categoriesmanager');
}

function deleteGroup ($exgroup) {
	global $_CB_database, $_CB_framework, $_PLUGINS;
	$sql = "SELECT id, name FROM #__gj_groups WHERE id='$exgroup'";
	$_CB_database->setQuery($sql);

	$result=$_CB_database->query();
	if (!$_CB_database->GetNumRows($result)) {
		HTML_wg::errorpage(GJ_GR_N_EX);
		return;
	} else {
		$sql = "DELETE FROM #__gj_bul WHERE group_id='$exgroup'";
		$_CB_database->setQuery($sql);
		if (!$result=$_CB_database->query()) {
			echo $_CB_database->stderr();
			return;
		};

		$sql = "DELETE FROM #__gj_active WHERE groups='$exgroup'";
		$_CB_database->setQuery($sql);
		if (!$result=$_CB_database->query()) {
			echo $_CB_database->stderr();
			return;
		};

		$sql = "DELETE FROM #__gj_users WHERE id_group='$exgroup'";
		$_CB_database->setQuery($sql);
		if (!$result=$_CB_database->query()) {
			echo $_CB_database->stderr();
			return;
		};

		$sql = "DELETE FROM #__gj_groups WHERE id='$exgroup'";
		$_CB_database->setQuery($sql);
		if (!$result=$_CB_database->query()) {
			echo $_CB_database->stderr();
			return;
		};

/*
		//If Joomlaboard is integrated, remove the group forum, check EventList integration while we're at it
		$sql = "SELECT jb, jb_cat, eventlist FROM #__gj_options";
		$_CB_database->setQuery($sql);
		$res = $_CB_database->loadObjectList();
*/
		$group['id'] = $exgroup;

		$_PLUGINS->trigger( 'gj_onAfterDeleteGroup', array( &$group, true ) );

/*
		//If EventList is integrated, remove the forum category
		if($res[0]->eventlist) {
		  $sql = "SELECT category_id FROM #__gj_eventlist WHERE group_id='$exgroup'";
		  $_CB_database->setQuery($sql);
		  $cat_id=$_CB_database->loadResult();

		  $sql = "DELETE FROM #__gj_eventlist WHERE group_id='$exgroup'";
		  $_CB_database->setQuery($sql);
		  if (!$result=$_CB_database->query()) {
		    echo $_CB_database->stderr();
				return;
		  }
		  $sql = "DELETE FROM #__eventlist_categories WHERE id='$cat_id'";
		  $_CB_database->setQuery($sql);
		  if (!$result=$_CB_database->query()) {
		    echo $_CB_database->stderr();
		    return;
		  }
*/

		$_CB_framework->redirect("index2.php?option=com_groupjive&task=groupsmanager", "Deleted");
		return;
//	}
}
}



function updateEvents() {
  global $_CB_database, $_CB_framework;

  /*Get all the groups without EventList categories*/
  $query="SELECT * FROM #__gj_groups WHERE id NOT IN (SELECT group_id FROM #__gj_eventlist)";
  $_CB_database->setQuery($query);
  $groups=$_CB_database->loadObjectList();
  $count=count($groups);

  if($count) {
    /*For every group that's not in #__gj_eventlist, create a new category*/
    foreach($groups as $group) {
      $query = "INSERT INTO #__eventlist_categories (catname, catdescription, image, publishedcat, checked_out, checked_out_time, access, ordering) VALUES ('".$_CB_database->getEscaped($group->name)."', '".$_CB_database->getEscaped($group->descr)."', '', '0', '0', '', '0', '')";
      $_CB_database->setQuery($query);
      if (!$result=$_CB_database->query()) {
	echo $_CB_database->stderr();
	return;
      }

      $lastid_el=$_CB_database->insertid();
      $query="INSERT INTO #__gj_eventlist (group_id, category_id) "
	. "VALUES ($group->id, $lastid_el)";
      $_CB_database->setQuery($query);
      if (!$result=$_CB_database->query()) {
	echo $_CB_database->stderr();
	return;
      }
    }
    $_CB_framework->redirect("index2.php?option=com_groupjive&task=settings", "Update successful");
    return;
	} else {
	  $_CB_framework->redirect("index2.php?option=com_groupjive&task=settings", "No groups needed updating");
	  return;
	}
}

function membersManager($option, $task){
  global $_CB_database, $_CB_framework, $acl;

  $filter_type	= $_CB_framework->getUserStateFromRequest( "filter_type{$option}", 'filter_type', 0 );
  $limit 			= intval( $_CB_framework->getUserStateFromRequest( "viewlistlimit", 'limit', $_CB_framework->getCfg( 'list_limit' ) ) );
  $limitstart 	= intval( $_CB_framework->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 ) );
  $search 		= $_CB_framework->getUserStateFromRequest( "search{$option}", 'search', '' );
  if (get_magic_quotes_gpc()) {
	  $search			= stripslashes( $search );
  }

  if (isset( $search ) && $search!= "") {
    $searchEscaped = $_CB_database->getEscaped( trim( strtolower( $search ) ) );
    $and = " AND (b.username LIKE '%$searchEscaped%' OR b.email LIKE '%$searchEscaped%' OR b.name LIKE '%$searchEscaped%')";
  } else {
    $and = '';
  }

  //Get total number of users in the system
  if( $filter_type ) {
    $query = "SELECT COUNT(g.id)"
      . "\nFROM #__gj_users AS x"
      . "\nLEFT JOIN #__gj_groups AS g"
      . "\nON x.id_group = g.id"
      . "\nINNER JOIN #__users AS b ON b.id = x.id_user"
      . "\nWHERE g.id = '$filter_type'"
      . "\nAND b.block = '0'";
  } else {
    $query = "SELECT COUNT(id)"
      . "\n FROM #__users WHERE block = '0'";
  }
  $_CB_database->setQuery( $query );
  $total = $_CB_database->loadResult();

	cbimport( 'cb.pagination' );

  $pageNav = new cbPageNav( $total, $limitstart, $limit  );

	$_CB_database->setQuery("DROP TEMPORARY TABLE IF EXISTS tmp_users;");
	$_CB_database->query();

	if( $filter_type ) {
	  $sql = "SELECT x.id_user"
	    . "\nFROM #__gj_users AS x"
	    . "\nLEFT JOIN #__gj_groups AS g"
	    . "\nON x.id_group = g.id"
	    . "\nINNER JOIN #__users AS b ON b.id = x.id_user"
	    . "\nWHERE g.id = '$filter_type'"
	    . "\nAND b.block = '0'"
	    . "\nLIMIT " . (int) $pageNav->limitstart . ", " . (int) $pageNav->limit;
	} else {
		$sql = "SELECT id AS id_user FROM #__users "
		  . "\nWHERE block = '0'"
		  . "\nLIMIT " . (int) $pageNav->limitstart . ", " . (int) $pageNav->limit;
	}

	$_CB_database->setQuery($sql);
	$tmp_ids = $_CB_database->loadResultArray();
	if ($_CB_database->getErrorNum()) {
	  echo $_CB_database->stderr();
	  return;
	}
	$tmp = implode(',', $tmp_ids);

	$query = "SELECT b.*, GROUP_CONCAT(g.id SEPARATOR ' ') AS groupids"
	  ."\nFROM #__users AS b "
	  ."\nLEFT JOIN #__gj_users AS u ON u.id_user = b.id"
	  ."\nLEFT JOIN #__gj_groups AS g ON u.id_group = g.id"
	  ."\nWHERE b.id IN ($tmp)"
	  .  $and
	  ."\nGROUP BY b.id"
	  ;

	$_CB_database->setQuery( $query);
	$rows = $_CB_database->loadObjectList();

	if ($_CB_database->getErrorNum()) {
		echo $_CB_database->stderr();
		return false;
	}

	$sql = "SELECT id, name FROM #__gj_groups";
	$_CB_database->setQuery( $sql);
	$gids = $_CB_database->loadObjectList();
	if ($_CB_database->getErrorNum()) {
		echo $_CB_database->stderr();
		return false;
	}
	$g = array();
	foreach ($gids as $gid) {
		$g[$gid->id] = $gid->name;
	}

	for ($i=0;$i<count($rows);$i++){
		$_ids = explode(' ',$rows[$i]->groupids);
		if (!empty($_ids[0])) {
			$rows[$i]->groupname ='<ul>';
			foreach ($_ids as $id) {
				$rows[$i]->groupname .= '<li><a href="index2.php?option=com_groupjive&task=membersmanager&filter_type='.$id.'">'.$g[$id].'</a></li>';
			}
			$rows[$i]->groupname .='</ul>';
		}
		else {
			$rows[$i]->groupname = '';
		}
	}

	// Get list of GJ groups for dropdown filter
	$query = "SELECT id AS value, name AS text"
	. "\n FROM #__gj_groups"
	. "\n ORDER BY name"
	;
	$types[] = groupjiveHTML::makeOption( '0', '- Select Group -' );
	$_CB_database->setQuery( $query );
	$types = array_merge( $types, $_CB_database->loadObjectList() );
	$lists['type'] = groupjiveHTML::selectList( $types, 'filter_type', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', "$filter_type" );

	HTML_wg::showMembers( $rows, $pageNav, $search, $option, $lists, $task );
}


function addMembers($option, $task, $cid) {
  global $_CB_database;
// Get list of GJ groups for dropdown filter
	$query = "SELECT id, name, descr"
	. "\n FROM #__gj_groups"
	. "\n ORDER BY name"
	;

	$_CB_database->setQuery($query);
	$rows = $_CB_database->loadObjectList();

  HTML_wg:: addMembers($rows, $option, $task, $cid);
}

function saveAddMembers($uid, $groups) {
  global $_CB_database, $_CB_framework;

  $val = array ();

  $query = "REPLACE INTO #__gj_users (id_user, id_group, status, date)"
    ."\nVALUES ";

  foreach($uid as $id)
    {
      foreach($groups as $group)
	{
	  $val [] = "($id, $group, 'active', 'now()')";

	    }
    }
  $query .= implode (",", $val);

  echo $query;

  $_CB_database->setQuery($query);
  if(!$result=$_CB_database->query()) {
    echo $_CB_database->stderr();
    return;
    }
  $_CB_framework->redirect("index2.php?option=com_groupjive&task=membersmanager", "Members were successfully added to the selected group(s)");
}

function saveDeleteMembers($uid, $groups) {
  global $_CB_database, $_CB_framework;
  if(count($groups)) echo "set"; else echo "Inte set";
  $val = array ();

    $query = "DELETE FROM #__gj_users WHERE ";

	$query1 = "DELETE FROM  #__gj_active WHERE ";

  foreach($uid as $id)
    {
      foreach($groups as $group)
	{
	  $val [] = "(id_user=$id AND id_group=$group)";
	    }
    }

  $query .= implode (" OR ", $val);

	// build SQL to delete entries from gj_active table (invitations)
  $query1 .= implode (" OR ", $val);
  $query1 = str_replace('id_group', 'groups', $query1);
  $query1 = str_replace('id_user', 'too', $query1);

  echo $query;
  $_CB_database->setQuery($query);
  if(!$result=$_CB_database->query()) {
    echo $_CB_database->stderr();
    return;
    }

  $_CB_database->setQuery($query1);
  if(!$result=$_CB_database->query()) {
    echo $_CB_database->stderr();
    return;
    }
   $_CB_framework->redirect("index2.php?option=com_groupjive&task=membersmanager", "Members were successfully deleted from the selected group(s)");
}


/**
 * Function saveConfig
 * @package groupjive
 * @description saves config into file - taken from CB thx ;)
 */
function saveConfig ( $option ) {
	global $_POST, $_CB_database;

	cbimport( 'cb.adminfilesystem' );
	$adminFS			=&	cbAdminFileSystem::getInstance();

	$configfile			=	GJADMINPATH."/components/com_groupjive/gj_config.php";

	//Add code to check if config file is writeable.
	if ( $adminFS->isUsingStandardPHP() && ! is_writable($configfile)) {
		@chmod ($configfile, 0766);
		if (!is_writable($configfile)) {
			cbRedirect("index2.php?option=$option", "FATAL ERROR: Config File Not writeable" );
		}
	}

	// safely evaluate post:
	$newConfig		=	array();
	foreach ( $_POST as $k => $v ) {
		$newVal		=	cbGetParam( $_POST, $k, '', _CB_ALLOWRAW | _CB_NOTRIM );

		if ( is_array( $newVal ) ) {
			$newVal	=	implode( '|*|', $newVal );
		}
		if ( strpos( $k, 'cfg_' ) === 0 ) {
			$newK	=	addslashes( substr( $k, 4 ) );
			$newConfig[$newK]	=	$newVal;
		}
	}

	// compose PHP gjconfig.php file:

	$txt = '<?php'."\n";
	foreach ( $newConfig as $k => $v ) {
			$txt .= "\$gjConfig['" . $k . "']='$v';\n";
	}

	//insert default logo
	if($_FILES['nophoto_logo']['size'] > 0) {
		$logo_def = create_picture($_FILES['nophoto_logo'],
					"groupjive_default", JPATH."/images/com_groupjive/");

		$txt .= "\$gjConfig['nophoto_logo']='$logo_def';\n";
	}
	else {
		$txt .= "\$gjConfig['nophoto_logo']='".cbGetParam( $_POST, 'old_nophoto_logo', '')."';\n";
	}

	$txt .= '?'.'>'; // sorry, but my editor has a problem with that and syntax highlighting ;)

	$result			=	$adminFS->file_put_contents( $configfile, $txt );
	
	if ( $result ) {

		// store settings into the database
 
		$sql = 'UPDATE #__gj_settingsstore SET settings = \''.$_CB_database->getEscaped($txt).'\' WHERE id = 1';
		$_CB_database->setQuery($sql);

		if (!$_CB_database->query()) {
			echo "<script> alert('"
				.$_CB_database->getErrorMsg()
				."'); window.history.go(-1); </script>\n";
		}


		if ( _gjAdmin_chmod( $configfile ) ) {
			$msg	=	"Configuration file saved";
		}
		else {
			$msg	=	'Failed to change the permissions of the config file '.$configfile;
		}
	}
	else {
		$msg		=	'Failed to create and write config file in '.$configfile;
	}

	if ( $result !== false ) {
		cbRedirect( "index2.php?option=$option&task=settings", $msg );
	}
	else {
		cbRedirect( "index2.php?option=$option", $msg . ': ' . "ERROR: Configuration file administrator/components/com_groupjive/gj_config.php could not be written by webserver. Please change file permissions in your web-pannel." );
	}
}


/**
 * Function _gjAdmin_chmod
 * @package groupjive
 * @description chmods a file
 */
function _gjAdmin_chmod( $filename ) {
	global $_CB_framework;

	cbimport( 'cb.adminfilesystem' );
	$adminFS			=&	cbAdminFileSystem::getInstance();

	$origmask			=	null;
	if ( $_CB_framework->getCfg( 'dirperms' ) == '' ) {
		// rely on umask
		// $mode			=	0777;
		return true;
	} else {
		$origmask		=	@umask( 0 );
		$mode			=	octdec( $_CB_framework->getCfg( 'dirperms' ) );
	}
	$ret				=	$adminFS->chmod( $filename, $mode );

	if ( isset( $origmask ) ) {
		@umask( $origmask );
	}
	return $ret;
}

?>
