<?php
/**
* @version $Id: bulletin.php
* @package Joomla!
* @subpackage GroupJive
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
* @Joomla! is Free Software
* @author Joshua Holmes
* @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
*/

/**
 * Bulletin functions
 */
// defines
defined( '_VALID_MOS' ) or defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class bulletin_controller extends groupjive_controller{

	function bulletin_controller( $option=null, $task=null, $parameters=array(), $ItemId ) {
		$this->groupjive_controller( $option, $task, $parameters, $ItemId );
	}

// 	switch($task) {
// 		// bulletin
// 		case 'bulletin':
// 			showbulletin();
// 			break;
//
// 		case 'editpost':
// 			editpost($exgroup);
// 			break;
//
// 		case 'savepost':
// 			savepost($exgroup);
// 			break;
//
// 		case 'deletepost':
// 			$postid=intval(cbGetParam($_REQUEST,'postid',-1));
// 			deletepost($postid);
// 			break;
//
// 		case 'archive':
// 			showArchive($exgroup);
// 			break;
//
// 		case 'addpost':
// 			addpost();
// 			break;
//
// 		case 'showfullmessage':
// 			showFullMessage($exgroup);
// 			break;
// 	}
	/**
	* shows the bulletin archive of a group
	* @param integer $group groupid
	*/
	function showarchive($groupid = null) {
		global $_CB_database, $_CB_framework, $gjConfig;

		if (!$groupid) {
			$groupid = intval( cbGetParam( $_REQUEST, 'groupid',0));
		}

		$query="SELECT COUNT(*) FROM #__gj_groups as a "
			. "INNER JOIN #__gj_grcategory as b ON a.category = b.id "
			. "WHERE b.access <= ".$_CB_framework->myCmsGid()." AND a.id='$groupid' AND b.published=1 AND active='1'";

		$_CB_database->setQuery($query);

		if ($_CB_database->loadResult() == 0) {
			HTML_wg::errorpage(GJ_GROUP_NOT_EXISTS, '', $groupid,'error');
			return;
		}

		$sql = "SELECT COUNT(*) FROM #__gj_bul "
			. "\nWHERE group_id='$groupid' ";
		$_CB_database->setQuery($sql);

		$limit = intval(cbGetParam( $_REQUEST, 'limit', $gjConfig['onpage'] ));
		$limitstart = intval(cbGetParam( $_REQUEST, 'limitstart', 0 ));

		cbImport('cb.pagination');
		$pageNav = new cbPageNav( $_CB_database->loadResult(), $limitstart, $limit  );

		if( $gjConfig['real_names'] ) {
			$name = "u.name";
		} else {
			$name = "u.username";
		}

		$query="SELECT a.*, ".$name." AS author_name FROM #__gj_bul AS a"
			. "\nINNER JOIN #__users AS u"
			. "\nON a.author_id = u.id"
			. "\nWHERE group_id='$groupid' "
			. "\nORDER BY id DESC"
			. "\nLIMIT " . (int) $pageNav->limitstart . ", " . (int) $pageNav->limit;

		$_CB_database->setQuery($query);
		$usrows=$_CB_database->loadObjectList();

		if ( count( $usrows ) ==0) {
			HTML_wg::errorpage(GJ_PAGE_NOT_EX, '', $groupid,'error');
			return;
		}

		$_CB_database->setQuery("SELECT COUNT(*) FROM #__gj_bul WHERE group_id='$groupid'");
		if (!$result=$_CB_database->query()) {
			echo $_CB_database->stderr();
			return;
		}

		HTML_wg::archive($usrows,$_CB_database->loadResult(), $groupid, $pageNav);
	}

	/**
	* shows the bulletin message of a group
	* @param integer $group groupid
	*/
	function showfullmessage($groupid = null) {
		global $_CB_database, $gjConfig, $_PLUGINS, $_GJ_TEMPLATES;
		$idm=cbGetParam($_REQUEST,'idm',-1);

		if (!$groupid) {
			$groupid = intval( cbGetParam( $_REQUEST, 'groupid',0));
		}

		if( $gjConfig['real_names'] ) {
			$name = "u.name";
		} else {
			$name = "u.username";
		}

		$query="SELECT b.* ,DATE_FORMAT(date_bul, '".$gjConfig['date_form']."') AS date_bul, "
			. "\n".$name." AS username "
			. "\nFROM #__gj_bul AS b"
			. "\nLEFT JOIN #__users AS u ON b.author_id = u.id"
			. "\nWHERE b.id='$idm' AND group_id='$groupid'";
		$_CB_database->setQuery($query);
		$da=$_CB_database->loadObjectList();

		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return;
		};

		if (! count( $da ) ) {
			HTML_wg::errorpage(GJ_MESSAGE_NOT_EXISTS, '', $groupid,'error');
			return ;
		}

		HTML_wg::showfullmessage($da);

		$_PLUGINS->trigger( 'gj_onAfterShowBulletin', array( &$da, true, &$_GJ_TEMPLATES ) );
	}

	/**
	* adds a post to a group
	* @param integer $group groupid
	*/
	function addpost(){
		global $_CB_database, $Itemid, $_CB_framework, $gjConfig;

		$bul = new groupJiveBulletin($_CB_database);

		// bind it to the table
		if (!$bul->bind($_POST)) {
			echo "<script> alert('"
			.$bul -> getError()
			."'); window.history.go(-1); </script>\n";
			exit();
		}

		if (!checkuseractive($bul->group_id, $_CB_framework->myId())) {
			HTML_wg::errorpage(GJ_ONLY_MEMBERS_CAN_POST, '', $bul->group_id,'error');
			return;
		}

		if( $gjConfig['wysiwyg']) {
			$post=cbGetParam($_POST,'message','', _MOS_ALLOWHTML);
		} else {
			$post=cbGetParam($_POST,'message','');
		}

		$subject=cbGetParam($_POST,'subject','');
		$post=trim($post);
		$post=nl2br($post);
		$post=stripslashes($post);

		$bul->post = $post;
		$bul->author_name = $_CB_framework->myUsername();
		$bul->author_id = $_CB_framework->myId();
		$bul->date_bul = date("Y-m-d H:i:s");

		if (empty($bul->post) || empty($bul->subject)) {
			HTML_wg::errorpage(GJ_FILL_REQ);
			return;
		}

		$bul->store();

		$group = new groupJiveGroup($_CB_database);
		$group->load($bul->group_id);

		// notification

		// notes: needs some testing (maybe format is not ok)
		// $message needs to be checked if inserted into Database, cause $post is not checked
		$message=str_replace("%p",$post,GJ_NEW_BUL);
		if ( $gjConfig['notify'] ) {
			notify($bul->group_id, $gjConfig['pms'], $message, $_CB_framework->myUsername(), 'notifyall');
		} else {
			notify($bul->group_id, $gjConfig['pms'], $message, $_CB_framework->myUsername());
		}

		$_CB_framework->redirect('index.php?option=com_groupjive&'
			.'action=gj.core.bulletin.showbulletin&amp;groupid='.$bul->group_id.'&amp;Itemid='.$Itemid, GJ_MESSAGE_WAS_ADDED );
	}


	/**
	* deletes a specific post
	* @param integer $postid postid
	*/
	function deletepost($postid = null) {
		global $_CB_database, $_CB_framework, $admin;

		if (!$postid) {
			$postid=intval(cbGetParam($_REQUEST,'postid',-1));
		}

		// get bulletin object
		$bul = new groupJiveBulletin($_CB_database);
		if (!$bul -> load($postid)) {
			HTML_wg::errorpage(GJ_MESSAGE_NOT_EXISTS);
			return;
		}

		// check if user is allowed to delete
		if ($bul->author_id != $_CB_framework->myId() && !$admin && !ismoder($bul->group_id,$_CB_framework->myId())) {
			HTML_wg::errorpage(GJ_NOT_MODER, '', $bul->group_id,'error');
			return;
		}

		if ($bul->delete($postid)) {
			HTML_wg::errorpage(GJ_MES_WAS_DELETED, '', $bul->group_id,'error');
		} else {
			HTML_wg::errorpage(GJ_MES_COULD_NOT_DELETED, '', $bul->group_id,'error');
		}
	}

	/**
	* stores a specific post
	* @param integer $group group
	*/
	function savepost($groupid){
		global $_CB_database, $_CB_framework, $admin, $Itemid, $gjConfig;

#TODO CHECK IF GROUP ID is passed
		if (!$groupid) {
			$groupid = intval( cbGetParam( $_REQUEST, 'groupid',0));
		}

		// this is called to save the edited post
		$g=intval(cbGetParam($_POST,'_g',-1));
		$i=intval(cbGetParam($_POST,'_i',-1));

		$bul = new groupJiveBulletin($_CB_database);
		$bul->load($i);

		if (!ismoder($g,$_CB_framework->myId()) && !$admin && !$_CB_framework->myId() == $bul->author_id)	{
			HTML_wg::errorpage(GJ_NOT_MODER, '', $groupid,'error');
			return;
		}

		$subject = trim(cbGetParam($_POST,'subject',''));

		if( $gjConfig['wysiwyg'] ) {
			$textpost=cbGetParam($_POST,'message','', _MOS_ALLOWHTML);
		} else {
			$textpost=trim(cbGetParam($_POST,'message',''));
		}

		if (empty($textpost)) {
			HTML_wg::errorpage(GJ_FILL_REQ, '', $groupid,'error');
			return;
		}

		$textpost=trim($textpost);
		//     $textpost=htmlspecialchars($textpost);
		$textpost=escapeString(nl2br($textpost));

		$query = "UPDATE #__gj_bul"
			. "\nSET post='$textpost',"
		        . "\nsubject='$subject'"
			. "\nWHERE id='$i'"
			. "\nAND group_id='$g'";
		$_CB_database->setQuery($query);
		if(!$result=$_CB_database->query()) {
			echo $_CB_database->stderr();
			return;
		}

		$_CB_framework->redirect('index.php?option=com_groupjive&amp;action=gj.core.bulletin.showbulletin&amp;groupid='.$g.'&amp;Itemid='.$Itemid, GJ_MES_WAS_EDITED);
	}

	/**
	* shows an edit form for a specific message
	* @param integer $group group
	*/
	function editpost($groupid = null){
		global $_CB_database, $_CB_framework, $admin;

		if (!$groupid) {
			$groupid = intval( cbGetParam( $_REQUEST, 'groupid',0));
		}

		//This function is only visible in the "Archive" for the Bulletin
		//Will allow you to edit and delete bulletins :)
		$postid=intval(cbGetParam($_REQUEST,'postid',-1));

		// get bulletin object
		$bul = new groupJiveBulletin($_CB_database);
		if (!$bul -> load($postid)) {
			HTML_wg::errorpage(GJ_MESSAGE_NOT_EXISTS);
			return;
		}

		if (!ismoder($bul->group_id,$_CB_framework->myId()) && !$admin  && ($_CB_framework->myId() != $bul->author_id) ) {
		HTML_wg::errorpage(GJ_NOT_MODER, '', $bul->group_id,'error');
		return;
	}

	          //Turn the object into an array
	        $arr = get_object_vars($bul);
		HTML_wg::editpost($arr);
	}


	/**
	* shows a bulletin overview
	*/
	function showbulletin(){
		global $_CB_framework, $_CB_database, $gjConfig;
		$gid = intval($_REQUEST['groupid']);

		if( $gjConfig['real_names'] ) {
			$name = "d.name";
		} else {
			$name = "d.username";
		}

		$query = "SELECT a.*, DATE_FORMAT(date_bul, '".$gjConfig['date_form']
			."') AS date_bul, ".$name." AS author_name "
			. "FROM #__gj_bul as a "
			. "INNER JOIN #__gj_groups as b ON a.group_id = b.id "
			. "INNER JOIN #__gj_grcategory as c ON b.category = c.id "
			. "INNER JOIN #__users as d ON a.author_id = d.id "
			. "WHERE group_id = '$gid' "
			. "AND c.access <= ".$_CB_framework->myCmsGid().' '
			. "AND c.published=1 "
			. "ORDER BY a.id DESC  LIMIT ".$gjConfig['blogm'];

		$_CB_database->setQuery($query);
		$blogrows=$_CB_database->loadObjectList();

		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return false;
		}

		HTML_wg::bulletin($gid, $blogrows);
	}
}
?>
