<?php
/**
* @version $Id: categories.php
* @package Joomla!
* @subpackage GroupJive
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
* @Joomla! is Free Software
* @author Joshua Holmes
* @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
*/

/**
 * Categories functions
 */
// defines
defined( '_VALID_MOS' ) or defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
* shows a category
*
*/

class categories_controller extends groupjive_controller{

	function categories_controller( $option=null, $task=null, $parameters=array(), $ItemId ) {
		$this->groupjive_controller( $option, $task, $parameters, $ItemId );
	}

	function showcategory() {
		global $_CB_database, $_CB_framework, $gjConfig, $Itemid, $admin;

		$_CB_framework->appendPathWay('TEXT');

		// get category ID
		$catid = intval( cbGetParam( $_REQUEST, 'catid',0));


		$sql = "SELECT *"
			. "\nFROM #__gj_grcategory"
			. "\nWHERE id = $catid"
			. "\nAND access <= ".$_CB_framework->myCmsGid()
			. "\nAND published=1";

		$_CB_database->setQuery($sql);

		$options_rows = $_CB_database->loadObjectList();

		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return false;
		}

		$options_row=&$options_rows[0];

		$_CB_framework->appendPathWay($options_row->catname);

		// Now get the right records depending on the page...
		// include pageNavigation class to build page navigation

		// types --> 1: GJ_OPEN   2: GJ_APREQUIRED  3: GJ_PRIVATE
		$whereHidePrivate = '';
		$joinHidePrivate = '';
		if ($gjConfig['hideprivate'] && !$admin) {
			$whereHidePrivate 	= "\nAND ( (a.type IN ('1', '2')) OR"
					. "\n(a.type IN ('3')AND x.id_user = ".$_CB_framework->myId()." ))";
			$joinHidePrivate 	= "\nLEFT JOIN #__gj_users x"
					. "\nON a.id = x.id_group";
		}

		$sql = "SELECT COUNT( DISTINCT a.id ) FROM #__gj_groups a"
			. "\nINNER JOIN #__gj_grcategory AS b "
			. "\nON a.category = b.id "
			. $joinHidePrivate
			. "\nWHERE category=$catid"
			. "\nAND active='1'"
			. "\nAND b.published=1"
			. "\nAND b.access <= ".$_CB_framework->myCmsGid()
			. $whereHidePrivate;

		$_CB_database->setQuery($sql);
		$total = $_CB_database->loadResult();

		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return false;
		}

		if ($total == 0){
			HTML_wg::showmenu();
			HTML_wg::errorpage(GJ_CAT_HASNT_G);
			return;
		}

		$limit = intval(cbGetParam( $_REQUEST, 'limit', $gjConfig['onpage'] ));
		$limitstart = intval(cbGetParam( $_REQUEST, 'limitstart', 0 ));

		cbImport('cb.pagination');
		$pageNav = new cbPageNav( $total, $limitstart, $limit  );

		$query="SELECT a.id,a.name,a.type,DATE_FORMAT(a.date_s, '".$gjConfig['date_form']."')"
			. "\nAS date_s,a.descr,a.logo, a.user_id, COUNT(c.id) AS groupusercount "
			. "\nFROM #__gj_groups AS a"
			. "\nINNER JOIN #__gj_grcategory AS b "
			. "\nON a.category = b.id "
			. "\nINNER JOIN #__gj_users c"
			. "\nON a.id = c.id_group"
			. $joinHidePrivate
			. "\nWHERE category=$catid"
			. "\nAND active='1'"
			. "\nAND b.published=1"
			. "\nAND b.access <= ".$_CB_framework->myCmsGid()
			. "\nAND c.status = 'active'"
			. $whereHidePrivate
			. "\nGROUP BY a.id, a.name, a.type, a.date_s, a.descr, a.logo, a.user_id"
			. "\nORDER BY name"
			. "\nLIMIT " . (int) $pageNav->limitstart . ", " . (int) $pageNav->limit;

		$_CB_database->setQuery($query);

		$rows=$_CB_database->loadAssocList();

		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return false;
		}

		if ($options_row->create_open || $options_row->create_closed || $options_row->create_invite) {
			HTML_wg::showmenu();
		}
		HTML_wg::showcat( $rows,$catid, $pageNav );
	}


	function showoverview() {
		global $_CB_database, $_CB_framework, $gjConfig;

		$admsql = '';

		if ($_CB_framework->myId()!=0) {
			$admsql = "\nOR admin=".$_CB_framework->myId();
		}

		$sql = "SELECT a.id, a.catname, a.cat_image,"
			. "\na.type, count(b.id) AS CAT_ISONLINE"
			. "\nFROM #__gj_grcategory a"
			. "\nLEFT JOIN #__gj_groups b"
			. "\nON a.id = b.category"
			. "\nAND (b.active='1' OR b.active IS NULL)"
			. "\nWHERE published = 1"
			. "\nAND (access <= ".$_CB_framework->myCmsGid()." "
			. $admsql.")"
		  	. "\nGROUP BY a.id, a.catname, a.cat_image,"
		  	. "\na.type"
			. "\nORDER BY ordering";

		$_CB_database->setQuery($sql);
		$rows = $_CB_database->loadAssocList();

		if($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return;
		}

		$col = count( $rows );
		if (!$col) {
			HTML_wg::errorpage(GJ_NO_CAT, '', 0,'error');
			return;
		}

		HTML_wg::showmenu();

		HTML_wg::showOverview($rows);
	}// end default

}
?>
