<?php
/**
* @version $Id: groups.php
* @package Joomla!
* @subpackage GroupJive
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
* @Joomla! is Free Software
* @author Joshua Holmes
* @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
*/

/**
 * Groups functions
 */
// defines
defined( '_VALID_MOS' ) or defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

/**
* stores groupinformation
* @param integer $group groupid
*/
// is this really needed? Yes!
if (!defined('GJBASEPATH')){define ( 'GJBASEPATH', 'components/com_groupjive');}


class groups_controller extends groupjive_controller{

	function groups_controller( $option=null, $task=null, $parameters=array(), $ItemId=0 ) {
		$this->groupjive_controller( $option, $task, $parameters, $ItemId );
	}
	function savegroup( $groupid=null ) {
		global $_CB_database, $admin, $_CB_framework,$Itemid, $ueConfig, $gjConfig, $_PLUGINS;
		//Receives info from function editgroup and handles the actual editing of the group
		$g=intval(cbGetParam($_POST,'_i','-1'));
		$n=escapeString(trim(cbGetParam($_POST,'gj_groupname','')));
		$d=escapeString(trim(cbGetParam($_POST,'gj_aboutgroup','')));
		$t=intval(cbGetParam($_POST,'type','-1'));

		if (!ismoder($g,$_CB_framework->myId()) && !$admin) {
			HTML_wg::errorpage(GJ_NOT_MODER, '', $g,'error');
			return;
		}

		if (empty($n)) {
			HTML_wg::errorpage(GJ_FILL_REQ, '', $g,'error');
			return;
		}

		$error = '';
		if( $_FILES['image_file']['size'] > 0 ) {
			$imgToolBox = new imgToolBox();
			$imgToolBox->_conversiontype	=$ueConfig['conversiontype'];
			$imgToolBox->_IM_path 			= $ueConfig['im_path'];
			$imgToolBox->_NETPBM_path 		= $ueConfig['netpbm_path'];
			$imgToolBox->_maxsize 			= $gjConfig['logosize'];
			$imgToolBox->_maxwidth 			= $gjConfig['logowidth'];
			$imgToolBox->_maxheight 		= $gjConfig['logoheight'];
			$imgToolBox->_thumbwidth 		= $gjConfig['thumbwidth'];
			$imgToolBox->_thumbheight 		= $gjConfig['thumbheight'];
			$imgToolBox->_debug = 0;

			foreach(glob(JPATH."/images/com_groupjive/".$g.".*") as $fn) {
				if (file_exists($fn)) {
					unlink($fn);
				}
			}

			if( ! $newFileName = $imgToolBox->processImage( $_FILES['image_file'], $g, JPATH."/images/com_groupjive/", 0, 0, 1 ) ) {
				$error = "<br/>The following error occured while processing your request: ";
				$error.= $imgToolBox->_errMSG . "";
			}
			$query="UPDATE #__gj_groups "
				. "SET name='$n', descr='$d', type='$t', logo='$newFileName' "
				. "WHERE id='$g'";

			$_CB_database->setQuery($query);
			if (!$result=$_CB_database->query()) {
				echo $_CB_database->stderr();
				return;
			}
		} else {
			$_CB_database->setQuery("UPDATE #__gj_groups SET name='$n', descr='$d', type='$t' WHERE id='$g'");
			if (!$result=$_CB_database->query()) {
				echo $_CB_database->stderr();
				return;
			}
		}

		$group['id'] 			= $g;
		$group['name'] 			= $n;

		$_PLUGINS->trigger( 'gj_onAfterUpdateGroup', array( $group, true, &$_GJ_TEMPLATES ) );


		if (EVENTLIST) {
	        $sql = "UPDATE #__eventlist_categories a"
	            . "\nINNER JOIN #__gj_eventlist b"
	            . "\nSET a.catname = '$n',"
	            . "\na.catdescription = '$d'"
	            . "\nWHERE a.id = b.category_id"
	            . "\nAND b.group_id = '$g'";
			$_CB_database->setQuery($sql);
			if (!$result=$_CB_database->query()) {
				echo $_CB_database->stderr();
				return;
			}
		}

		//HTML_wg::errorpage(GJ_GROUP_INFO_WAS_EDITED);
		if ($error) {
			$_CB_framework->redirect( 'index.php?option=com_groupjive'
			. '&amp;action=gj.core.groups.editgroup&amp;Itemid='.$Itemid.'&amp;groupid='.$g, $error );
		} else {
			$url = "index.php?option=com_groupjive"
				. "&amp;action=gj.core.groups.showgroup&amp;Itemid=".$Itemid."&amp;groupid=".$g;
			$_CB_framework->redirect($url, GJ_GROUP_INFO_WAS_EDITED );
		}
	}

	/**
	* shows an editform for a group
	* @param integer $group groupid
	*/
	function editgroup($groupid = null) {
		global $_CB_database, $admin, $_CB_framework;

		if (!$groupid) {
			$groupid = intval( cbGetParam( $_REQUEST, 'groupid',0));
		}

		//this will allow you to edit the information regarding the group... Even the name...
		if (!ismoder($groupid, $_CB_framework->myId()) && !$admin)	{
			HTML_wg::errorpage(GJ_NOT_MODER, '', $groupid,'error');
			return;
		}

		$query="SELECT a.id, a.name, a.descr, a.type, a.user_id, "
			. "b.create_open, b.create_closed, b.create_invite "
			. "FROM #__gj_groups as a, #__gj_grcategory as b "
			. "WHERE a.id=$groupid AND b.id=a.category AND b.published=1 AND active='1'";
		$_CB_database->setQuery($query);

		$rows=$_CB_database->loadObjectList();
		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return;
		};

		if ( count( $rows ) == 0) {
			HTML_wg::errorpage(GJ_GROUP_NOT_EXISTS, '', $groupid,'error');
			return;
		}

		HTML_wg::editgroup($rows);
		$_CB_framework->appendPathWay(GJ_EDIT_GROUP_INFO);
	}

	/**
	* deletes a specific group
	* @param integer $group groupid
	*/
	function deletegroup($groupid = null) {
		global $_CB_database, $_CB_framework, $admin, $Itemid, $gjConfig, $_PLUGINS;
		//Because DeleteGroup handler was in URL go ahead and delete
		// the group..
		//By the way $exgroup is the variable with the group ID in it CHEERS

		if (!$groupid) {
			$groupid = intval( cbGetParam( $_REQUEST, 'groupid',0));
		}

		if ( !$gjConfig['delete_groups'] ) {
			HTML_wg::errorpage(GJ_DELETE_GROUP_NOT_ALLOWED, '', $groupid,'error');
			return;
		}

		if (!ismoder($groupid,$_CB_framework->myId()) && !$admin) {
			HTML_wg::errorpage(GJ_NOT_MODER, '', $groupid,'error');
			return;
		}

		$g = new groupJiveGroup($_CB_database);
		$g->load($groupid);

		// delete images
		foreach(glob(JPATH."/images/com_groupjive/".$groupid.".*") as $fn) {
			if (file_exists($fn)) {
				unlink($fn);
			}
		}
		foreach(glob(JPATH."/images/com_groupjive/tn".$groupid.".*") as $fn) {
			if (file_exists($fn)) {
				unlink($fn);
			}
		}

		if ($g->deleteAll()) {
			$state = GJ_GROUP_WAS_DELETED;
		} else {
			$state = "Error: ".$g->getError;
		}

		$group['id'] = $groupid;
		$_PLUGINS->trigger( 'gj_onAfterDeleteGroup', array( &$group, true, &$_GJ_TEMPLATES ) );

		$_CB_framework->redirect( 'index.php?option=com_groupjive&amp;Itemid='.$Itemid, $state);
	}

	/**
	* shows a specific group
	* @param integer $gid groupid
	*/
	function showgroup($gid = null, $size='') {
		global $_CB_database,$_CB_framework, $Itemid, $admin, $mypic, $gjConfig, $_GJ_TEMPLATES, $_PLUGINS;

		if(!$gid) {
			$gid = intval(cbGetParam($_REQUEST, 'groupid', 0));
		}

		$_CB_framework->addCustomHeadTag('<script src="'.$_CB_framework->getCfg( 'live_site' )
				. '/components/com_groupjive/js/functions.js" type="text/javascript"></script>');

		//	if(JB) {

		$query="SELECT a.*, a.name AS groupname, DATE_FORMAT(date_s, '".$gjConfig['date_form']."') AS date_s, "
				. "b.catname, b.id AS catid, "
				. "d.name, d.username, e.category_id AS category_id_el "
				. "FROM #__gj_groups as a INNER JOIN #__gj_grcategory AS b "
				. "ON a.category = b.id "
				. "INNER JOIN #__users as d "
				. "ON a.user_id = d.id "
				. "LEFT JOIN #__gj_eventlist as e "
				. "ON a.id = e.group_id "
				. "WHERE a.id='$gid' AND b.access <= ".$_CB_framework->myCmsGid();

		if (!$admin) {
			$query .= " AND a.active='1'";
		}

			/*	} else {
			$query="SELECT a.*, a.name AS groupname, DATE_FORMAT(date_s, '$date_format') AS date_s, c.name, "
				. "b.id AS catid, b.catname"
				. "\nFROM #__gj_groups AS a INNER JOIN #__gj_grcategory AS b "
				. "ON a.category = b.id "
				. "INNER JOIN #__users as c "
				. "ON a.user_id = c.id "
				. "WHERE a.id='$gid' AND a.active='1' AND b.access <= ".$_CB_framework->myCmsGid();
				}*/

		$_CB_database->setQuery($query);
		$rows=$_CB_database->loadObjectList();
		if($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return;
		}

		$exist = count( $rows );

		if ((!$exist) || ($exist!=1)) {
			HTML_wg::errorpage(GJ_GROUP_NOT_EXISTS, '', $gid,'error');
			return;
		}

		$row=&$rows[0];

		$content = implode("\n", $_PLUGINS->trigger( 'gj_onBeforeShowGroup', array( &$row, true ) ));
		$_GJ_TEMPLATES->addContent($content, 'center');

		// check if new users joined the group, whom need to activate
		$newusers ='';
		if ($row->user_id == $_CB_framework->myId()) {
			$query="SELECT COUNT(*) FROM #__gj_users "
				. "WHERE id_group =$gid AND status = 'need approval'";

			$_CB_database->setQuery($query);
			$countusers = $_CB_database->loadResult();

			if ($countusers > 0 ) {
				$_CB_framework->addCustomHeadTag('<script type="text/javascript">alert(\''.GJ_NEW_USERS_NEED_ACTIVATION.'\')</script>');
				echo  '<p><a href="index.php?option=com_groupjive&'
					. 'action=gj.core.members.showinactiveusers&amp;groupid='.$gid.'&amp;Itemid='.$Itemid
					. '">'.GJ_NEW_USERS_NEED_ACTIVATION.'</a></p>';
			}
		}

		$query="SELECT avatar FROM #__comprofiler WHERE id=".$row->user_id;
		$_CB_database->setQuery($query);
		$founder = $_CB_database->loadResult();

		if (file_exists('images/comprofiler/tn'.$founder) && (!PIC2PIC || (PIC2PIC && $mypic))) {
			$image='images/comprofiler/tn'.$founder;
		} else if( file_exists('images/comprofiler/tn'.$founder) && PIC2PIC && !$mypic) {
			if (file_exists('components/com_comprofiler/images/'.$_CB_framework->getCfg( 'lang' ).'/tnnophoto.jpg'))
			$image='components/com_comprofiler/images/'.$_CB_framework->getCfg( 'lang' ).'/tnnophoto.jpg';
			else $image='components/com_comprofiler/images/english/tnnophoto.jpg';
		} else if (substr($founder, 0, 7) == 'gallery' && file_exists('images/comprofiler/'.$founder)) {
			$image='images/comprofiler/'.$founder;
		} else {
				$image = $gjConfig['nophoto'];
		}

		$image = '<img src="'.$image.'" alt="'.$row->creator.'"/>';

		// types --> 1: GJ_OPEN   2: GJ_APREQUIRED  3: GJ_PRIVATE
		$actions = '<ul id="gj_list_standard_funcs">';

		$row->userActive = checkuseractive($row->id,$_CB_framework->myId());

		if (($row->type == 3) && (!$row->userActive && !$admin)) {
			HTML_wg::errorpage(GJ_NOTAUTH.'<br/>'.GJ_PLEASE_LOGIN, '', $row->id,'error');
		} else if (($row->type == 2) && (!checkuser($row->id,$_CB_framework->myId()) && !$admin)){
			HTML_wg::errorpage('<a href="'
				. cbSef("index.php?option=com_groupjive"
				. "&amp;action=gj.core.groups.sign&amp;groupid=$row->id").'">'
				. GJ_SIGN.'</a>', GJ_ERROR_JOIN_GROUP_L1.'<br/>'.GJ_ERROR_JOIN_GROUP_L2, $row->id,'error');
		} else if (($row->type == 2) && (!$row->userActive && !$admin)){
			HTML_wg::errorpage(GJ_PENDING, '', $row->id,'error');
		} else {
			if(!checkuser($row->id,$_CB_framework->myId()) && $_CB_framework->myId()) {
				$actions .= '<li><a href="'
					. cbSef("index.php?option=com_groupjive"
					. "&amp;action=gj.core.groups.sign&amp;groupid=$row->id&"
					. "Itemid=$Itemid").'">'.GJ_SIGN.'</a></li>';
			} elseif( $row->userActive ) {
				$actions .= '<li><a href="'
					. cbSef("index.php?option=com_groupjive"
					. "&amp;action=gj.core.groups.sign&amp;groupid=$row->id&"
					. "Itemid=$Itemid").'">'.GJ_INVITE.'</a></li>';
				if (!ismoder($gid,$_CB_framework->myId())) {
					$actions .= '<li><a href="'
						. cbSef("index.php?option=com_"
						. "groupjive&amp;action=gj.core.members.deletemember&amp;groupid=$gid&"
						. "userid=".$_CB_framework->myId()."&amp;Itemid=$Itemid")
						. '" onclick="return confirm(\''
						. GJ_DELETE_SELF_CONFIRM .'\')">'
						. GJ_LEAVE_GROUP.'</a></li>';
				}
			$actions .= '<li><a href="'
	              . cbSef("index.php?option=com_groupjive&amp;action="
	              . "gj.core.mail.mailowner&amp;groupid=$row->id&amp;Itemid=$Itemid")
	              . '">'.GJ_MAIL_OWNER.'</a></li>';

			} else {
			// occurs when admin is viewing a group without being a member
			// HTML_wg::errorpage("this shouldn't happen..", '', $row->id,'error');
			}

			$actions .= '</ul>';
			if (ismoder($row->id,$_CB_framework->myId()) || $admin) {
				$moderator_func = moderator_func($row);
			} else {
				$moderator_func = "";
			}

			if((!empty($row->logo))
				&& ($row->logo != '0')
				&& (file_exists("images/com_groupjive/".$row->logo))) {

				$c = filemtime ("images/com_groupjive/".$row->logo);
				$logo = '<img align="left" src="'.$_CB_framework->getCfg( 'live_site' )
					. '/images/com_groupjive/'.$row->logo
					. '?ac='.$c.'" alt="'.stripslashes($row->groupname).'" />';
			} else {
				$logo = '<img align="left" src="'.$_CB_framework->getCfg( 'live_site' )
					. '/images/com_groupjive/'.$gjConfig['nophoto_logo']
					. '" alt="default logo" />';
			}

			HTML_wg::showGroup($row, $newusers, $logo, $image, $actions, $moderator_func, $size);

			$_CB_framework->appendPathWay($row->catname, cbSef('index.php?option=com_groupjive&amp;action=gj.core.categories.showcategory&amp;catid='.$row->catid.'&amp;Itemid='.$Itemid));


			if($this->_task == 'showgroup') {
				main_page($row);
				$_CB_framework->appendPathWay(stripslashes($row->groupname));
			} else {
				$_CB_framework->appendPathWay(stripslashes($row->groupname), cbSef('index.php?option=com_groupjive&amp;action=gj.core.groups.showgroup&amp;groupid='.$row->id.'&amp;Itemid='.$Itemid));
			}
		}

		$_PLUGINS->trigger( 'gj_onAfterShowGroup', array( &$row, true, &$_GJ_TEMPLATES ) );
	}

	/**
	* adds a new group
	*
	*/
	function addnewgroup() {
		global $_CB_framework,$_CB_database, $ueConfig, $gjConfig, $_PLUGINS;
		global $jb_cat, $Itemid;

		$livesite 	= $_CB_framework->getCfg( 'live_site' );

		$name		= trim(cbGetParam($_POST,'gj_groupname'));
		$descr		= trim(cbGetParam($_POST,'gj_aboutgroup'));
		$type		= intval(cbGetParam($_POST,'type'));
		$cat		= intval(cbGetParam($_POST,'category'));

		if( $_FILES['image_file']['size'] > 0 ) {
			$image_file =  $_FILES['image_file'];
		}

		if (!$_CB_framework->myId()) {
			HTML_wg::errorpage(GJ_NOTAUTH, '', $group,'error');
			return;
		}

		$sql = "SELECT *"
			."\nFROM #__gj_grcategory"
			."\nWHERE access <= ".$_CB_framework->myCmsGid()
			."\nAND published=1 ";
		$_CB_database->setQuery($sql);
		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return false;
		}

		$rows=$_CB_database->loadObjectList();
		//If the options are set to send emails on group creation then
		//$gjConfig['send_admin_emails'] will equal 1

		if (empty($name) || empty($type)) {
			HTML_wg::newgroup($rows,$name,$descr,GJ_FILL_REQ);
			return;
		}

		$query = "SELECT COUNT(*) FROM #__gj_groups WHERE name='".escapeString($name)."'";
		$_CB_database->setQuery( $query );

		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return false;
		}

		$count=$_CB_database->loadResult();
		if ($count != 0) {
			HTML_wg::newgroup($rows,$name,$descr,GJ_GROUPNAME_EXISTS);
			return;
		} else {
			$creator=$_CB_framework->myUsername();
			if ( $gjConfig['approval'] ) {
				$awqw=0;
			} else {
				$awqw=1;
			}

			$query="INSERT INTO #__gj_groups ("
				. "name, "
				. "descr, "
				. "date_s, "
				. "type, "
				. "creator, "
				. "user_id, "
				. "active, "
				. "category) "
				. "VALUES ('"
				. escapeString($name)."','"
				. escapeString($descr)."', "
				. "now(),'"
				. $type."','"
				. $creator."','"
				. $_CB_framework->myId()."','"
				. $awqw."','"
				. $cat."')";

			$_CB_database->setQuery($query);
			if (!$_CB_database->query()) {
				echo $_CB_database->stderr();
				return false;
			}
			$lastid=$_CB_database->insertid();

			$error = '';
			if( $image_file['size'] > 0 ) {
				$imgToolBox = new imgToolBox();
				$imgToolBox->_conversiontype	= $ueConfig['conversiontype'];
				$imgToolBox->_IM_path 			= $ueConfig['im_path'];
				$imgToolBox->_NETPBM_path 		= $ueConfig['netpbm_path'];
				$imgToolBox->_maxsize 			= $gjConfig['logosize'];
				$imgToolBox->_maxwidth 			= $gjConfig['logowidth'];
				$imgToolBox->_maxheight 		= $gjConfig['logoheight'];
				$imgToolBox->_thumbwidth 		= $gjConfig['thumbwidth'];
				$imgToolBox->_thumbheight 		= $gjConfig['thumbheight'];
				$imgToolBox->_debug 			= 0;

				if( ! $newFileName = $imgToolBox->processImage( $image_file, $lastid, JPATH."/images/com_groupjive/", 0, 0, 1 ) ) {
					$error = "<br/>The following error occured while processing your request:<br/>\n";
					$error .= $imgToolBox->_errMSG . "<br/>\n";
				}
			}

			$query="UPDATE #__gj_groups SET logo='".$newFileName."' WHERE id='".$lastid."'";
			$_CB_database->setQuery($query);
			if (!$_CB_database->query()) {
				echo $_CB_database->stderr();
				return false;
			}

			$query="INSERT "
				. "\nINTO #__gj_users (id_user,username,id_group,date, status)"
				. "\nVALUES (".$_CB_framework->myId().",'".escapeString($_CB_framework->myUsername())."',"
				. "\n'$lastid', now(), 'active')";

			$_CB_database->setQuery($query);
			if (!$_CB_database->query()) {
				echo $_CB_database->stderr();
				return false;
			}

			$category = new groupJiveCategory( $_CB_database );
			$category->load($cat);

			$group['id'] 			= $lastid;
			$group['name'] 			= escapeString($name);
			$group['description']	= escapeString($descr);
			$group['creatorname'] 	= $creator;
			$group['creatorid'] 	= $_CB_framework->myId();

			$_PLUGINS->trigger( 'gj_onAfterCreateGroup', array( &$group, true ) );

			if(EVENTLIST) {
			  $_CB_database->setQuery("SELECT category_id FROM #__gj_eventlist WHERE group_id=$g_id");
			  $cat_id_eventlist = $_CB_database->loadResult();
			  if(!$cat_id_eventlist) {
			    $query = "INSERT INTO #__eventlist_categories (catname, catdescription, image, publishedcat, checked_out, checked_out_time, access, ordering) VALUES ('".$name."', '".$descr."', '', '0', '0', '', '0', '')";
			    $_CB_database->setQuery($query);
			    $_CB_database->query();

			    $lastid_el=$_CB_database->insertid();
			    $query="INSERT INTO #__gj_eventlist (group_id, category_id) "
			      . "VALUES ($lastid, $lastid_el)";
			    $_CB_database->setQuery($query);
			    $_CB_database->query();
			  }

			}
		}

			//    HTML_wg::groupcreated( NEEDAPPROVAL);

			if ($gjConfig['send_admin_emails'] =='1') {
				//send email to admin
				$message= GJ_NEWGROUPCREATED;
				$grouplinkfrontend = 'index.php?option=com_groupjive&action=gj.core.groups.showgroup&groupid='.$group['id'].'&Itemid='.$Itemid ;
				$grouplinkactivate = 'administrator/index2.php?option=com_groupjive&task=publishgroup&cid='.$group['id'] ;

				$message = str_replace("%groupname", 			$group['name'], 		$message);
				$message = str_replace("%categoryname",			$category->catname,		$message);
				$message = str_replace("%groupdescription", 	$group['description'], 	$message);
				$message = str_replace("%grouplinkfrontend", 	$grouplinkfrontend, 	$message);
				$message = str_replace("%groupactivate", 		$grouplinkactivate, 	$message);

				gjMail($_CB_framework->getCfg( 'mailfrom' ), "Admin Groups Messenger", $gjConfig['admin_email'], "New Group Waiting For Approval", $message);
			}

			if ( $gjConfig['approval'] ) {
				$_CB_framework->redirect( 'index.php?option=com_groupjive'
					. '&amp;Itemid='.$Itemid,
					GJ_GROUP_WAS_CREATED_APP.$error );
			} else {
				$_CB_framework->redirect( 'index.php?option=com_groupjive'
					. '&amp;action=gj.core.groups.showgroup&amp;groupid='.$lastid.'&amp;Itemid='.$Itemid,
					GJ_GROUP_WAS_CREATED.$error );
			}
	}


	/**
	* shows new group form
	*/
	function createnewgroup() {
		global $_CB_framework, $_CB_database;

		HTML_wg::showmenu();

		if (!$_CB_framework->myId()) {
			HTML_wg::errorpage(GJ_NOTAUTH);
			return;
		}

		$query="SELECT *"
			. "\nFROM #__gj_grcategory"
			. "\nWHERE access <= ".$_CB_framework->myCmsGid()
			. "\nAND published=1"
			. "\nORDER BY catname";
		$_CB_database->setQuery($query);
		$rows=$_CB_database->loadObjectList();

		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return false;
		}

		HTML_wg::newgroup($rows);
	}

	function sign ($groupid = null) {
		global $_CB_database, $_CB_framework, $Itemid, $gjConfig;

		if (!$groupid) {
			$groupid = intval( cbGetParam( $_REQUEST, 'groupid',0));
		}

		$friendname = cbGetParam( $_REQUEST, 'friendname', '');
		$usersfound = array();
		$pageNav 	= '';

		if ( $friendname ) {
			
			$where = '';
			$order = '';
			$name  = '';

			// search for the friend
			if ($gjConfig['real_names']) {
				$where 	.= "\nname LIKE '%".$_CB_database->getEscaped( $friendname )."%'";
				$order	.= "\nORDER BY name";
				$name	 = 'name';
			}
			else {
				$where 	.= "\nusername LIKE '%".$_CB_database->getEscaped( $friendname )."%'";
				$order	.= "\nORDER BY username";
				$name	 = 'username as name';
			}

			$sql = 'SELECT count(*) FROM #__users WHERE '.$where;
			$_CB_database->setQuery($sql);
			$count = $_CB_database->loadResult();

			$sql = 'SELECT id, '.$name.' from #__users WHERE '.$where. $order;

			$limit = intval(cbGetParam( $_REQUEST, 'limit', $gjConfig['onpage'] ));
			$limitstart = intval(cbGetParam( $_REQUEST, 'limitstart', 0 ));

			cbImport('cb.pagination');

			$pageNav = new cbPageNav( $count, $limitstart, $limit  );

			$sql .= "\nLIMIT " . (int) $pageNav->limitstart . ", " . (int) $pageNav->limit;

			$_CB_database->setQuery($sql);

			$usersfound = $_CB_database->loadAssocList();
		}

		$query="SELECT a.*, b.access, DATE_FORMAT(a.date_s, '".$gjConfig['date_form']."') AS date_s "
			. "FROM #__gj_groups a INNER JOIN #__gj_grcategory b "
			. "ON a.category = b.id "
			. "WHERE a.id=$groupid AND a.active='1'";

		$_CB_database->setQuery($query);
		$rows=$_CB_database->loadObjectList();

		if($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return;
		}

		if ( count( $rows ) == 0) {
			HTML_wg::errorpage(GJ_GROUP_NOT_EXISTS, '', $groupid,'error');
			return;
		}

		$row=&$rows[0];

		if (!$_CB_framework->myId() || !($row->access <= $_CB_framework->myCmsGid()) ) {
			HTML_wg::errorpage(GJ_NOTAUTH, '', $groupid,'error');
			return;
		}

		switch($row->type) {
			case 1:
				if (checkuseractive($groupid,$_CB_framework->myId())) {
					HTML_wg::invite($row, $friendname, $usersfound, $pageNav);
					return;
				}
				$query="REPLACE INTO #__gj_users (id_user,id_group, date, status) "
					. "VALUES (".$_CB_framework->myId().",$groupid, now(), 'active')";
				$_CB_database->setQuery($query);


				if(!$result=$_CB_database->query()) {
					echo $_CB_database->stderr();
					return;
				}
				if ($_CB_database->getAffectedRows()) {

					// NOTIFYJOIN is not ignored but noted in the notify function
					// except for email and clexus - this needs to be done when
					// the PMS class is working
					// meanwhile this is a workaround (the admin now gets no message)
					$name = $_CB_framework->myUsername();

					if ( $gjConfig['real_names'] ) {
						$myId = $_CB_framework->myId();
						if ( $myId ) {
							$cbUser		=&	CBuser::getInstance( $myId );
							$name = $cbUser->_cbuser->name;
						}
					}

					if ( $gjConfig['notifyjoin'] ){
						notify($groupid, $gjConfig['pms'], GJ_NEW_MEMBER, $name, 'notifyall');
					} else {
						notify($groupid, $gjConfig['pms'], GJ_NEW_MEMBER, $name);
					}

					$_CB_framework->redirect( 'index.php?option=com_groupjive&'
						. 'action=gj.core.groups.showgroup&amp;groupid='
						. $groupid.'&amp;Itemid='
						. $Itemid, GJ_WELCOME );
				} else {
					$_CB_framework->redirect( 'index.php?option=com_groupjive&'
						. 'action=gj.core.groups.showgroup&amp;groupid='
						. $groupid.'&amp;Itemid='
						. $Itemid, GJ_ALREADY_MEMBER );
				}
				break;

			case '2':
				 if (checkuseractive($groupid,$_CB_framework->myId())) {
					HTML_wg::invite($row, $friendname, $usersfound, $pageNav);
					return;
				}

				$query="REPLACE INTO #__gj_users (id_user,username,id_group, "
					. "status) VALUES ('".$_CB_framework->myId()."','".$_CB_framework->myUsername()."',$groupid,'need approval')";

				$_CB_database->setQuery($query);
				if(!$result=$_CB_database->query()) {
					echo $_CB_database->stderr();
					return;
				}

				if ($_CB_database->getAffectedRows()) {

					// NOTIFYJOIN is not ignored but noted in the notify function
					// except for email and clexus - this needs to be done when
					// the PMS class is working
					// meanwhile this is a workaround (the admin now gets no message)
					$name = $_CB_framework->myUsername();

					if ( $gjConfig['real_names'] ) {
						$myId = $_CB_framework->myId();
						if ( $myId ) {
							$cbUser		=&	CBuser::getInstance( $myId );
							$name = $cbUser->_cbuser->name;
						}
					}

					if ( $gjConfig['notifyjoin'] ){
							notify($groupid, $gjConfig['pms'], GJ_NEW_MEMBER, $name, 'notifyall');
					} else {
						notify($groupid, $gjConfig['pms'], GJ_NEW_MEMBER, $name);
					}

					HTML_wg::errorpage(GJ_WELCOME2, '', $groupid,'error');
				} else {
					HTML_wg::errorpage(GJ_ALREADY_MEMBER, '', $groupid,'info');
				}
				break;

			case '3':
				HTML_wg::invite($row, $friendname, $usersfound, $pageNav);
				break;
		}
	}
}
?>
