<?php
/**
* @version $Id: mail.php
* @package Joomla!
* @subpackage GroupJive
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
* @Joomla! is Free Software
* @author Joshua Holmes
* @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
*/


/**
 * Mail functions
 */
// defines
defined( '_VALID_MOS' ) or defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class mail_controller extends groupjive_controller{

	function mail_controller( $option=null, $task=null, $parameters=array(), $ItemId ) {
		$this->groupjive_controller( $option, $task, $parameters, $ItemId );
	}

	function mailowner () {
		include ('groups.php');
		$option  = cbGetParam($_REQUEST, 'option', 'com_groupjive');
		$groupid = intval(cbGetParam($_REQUEST, 'groupid', 0));
		groups_controller::showgroup($groupid, 'mini');
		$this->showmailform('mailowner', $option, $groupid, '', '', '', false, false);
	}

	function mailgroupmembers () {
		include ('groups.php');
		$option  = cbGetParam($_REQUEST, 'option', 'com_groupjive');
		$groupid = intval(cbGetParam($_REQUEST, 'groupid', 0));
		groups_controller::showgroup($groupid, 'mini');
		$this->showmailform('mailgroup', $option, $groupid, '', '', '', false, false);
	}

	function showmailform($type, $option, $groupid, $message='', $subject='', $body='', $copy=true, $showgroup=true){
		global $_CB_framework, $_CB_database, $Itemid;

		HTML_wg::showMailForm($type, $groupid, $subject, $body, $copy, $message, $showgroup);

		$sql = "SELECT a.name AS groupname, a.id, b.catname, b.id AS catid FROM #__gj_groups AS a"
		."\nINNER JOIN #__gj_grcategory AS b"
		."\nON a.category = b.id"
		."\nWHERE a.id = ".$groupid;
		$_CB_database->setQuery($sql);
		$rows = $_CB_database->loadObjectList();

		if ($_CB_database->getErrorNum()) {
		echo $_CB_database->stderr();
		return false;
		}

		$row = $rows[0];

		if($type == 'mailgroup') $_CB_framework->appendPathWay(GJ_MAIL_GROUP);
		if($type == 'mailowner') {
		$_CB_framework->appendPathWay($row->catname, cbSef('index.php?option=com_groupjive&amp;action=gj.core.categories.showcategory&amp;catid='.$row->catid.'&amp;Itemid='.$Itemid));
		$_CB_framework->appendPathWay(stripslashes($row->groupname), cbSef('index.php?option=com_groupjive&amp;action=gj.core.groups.showgroup&amp;groupid='.$row->id.'&amp;Itemid='.$Itemid));
		$_CB_framework->appendPathWay(GJ_MAIL_OWNER);
	}
	}

	function mailgroupowner() {
		$option		= cbGetParam($_REQUEST, 'option', 'com_groupjive');
		$groupid	= intval(cbGetParam($_REQUEST, 'groupid', 0));
		$task		= 'mailgroupowner';

		$this->_mailgroup($option, $groupid, $task);
	}
	
	function mailgroup() {
		$option		= cbGetParam($_REQUEST, 'option', 'com_groupjive');
		$groupid	= intval(cbGetParam($_REQUEST, 'groupid', 0));
		$task		= 'mailgroup';

		$this->_mailgroup($option, $groupid, $task);
	}

	function _mailgroup ($option, $gid, $task) {
		global $_CB_database, $Itemid, $_CB_framework;

		$copy = cbGetParam($_POST, 'copy', '');
		$subject = cbGetParam($_POST, 'subject', '');
		$body = cbGetParam($_POST, 'body', '');

		$subject = stripslashes( strval( $subject));
		$body = stripslashes( strval( $body));

		$group = new groupJiveGroup($_CB_database);
		$group->load($gid);

		if (!$subject) {
			$error[] = GJ_MAIL_NO_SUBJECT;
		}
		if (!$body) {
			$error[] = GJ_MAIL_NO_BODY;
		}

		if ($task =='mailgroupowner') {
			$showgroup=false;
			$type = 'mailowner';
		} else {
			$showgroup=true;
			$type = 'mailgroup';
		}

		if (isset($error)) {
			showMailForm($type, $option, $gid, implode('<br/>', $error), $subject, $body, $copy, $showgroup);
			return;
		}

		if ($task =='mailgroupowner') {
	//	echo("owner");
			$subject = $subject;

			if ($this->mailToGroupMember($_CB_framework->myId(), $group->user_id, $gid, $body, $subject)) {
				$res = GJ_MAILS_WERE_SENT;
			} else {
				$res = GJ_MAILS_WERE_NOT_SENT;
			}
			$_CB_framework->redirect( 'index.php?option=com_groupjive'
				. '&amp;action=gj.core.groups.showgroup&amp;Itemid='.$Itemid.'&amp;groupid='.$gid, $res );
		} else {
			if (!$group->getUsersOfGroup()) {
				HTML_wg::errorpage("error:".$group->getError(), '', $group->id,'error');
				return;
			}

			foreach ($group->users as $user) {
			if (!($copy!='on' && $_CB_framework->myId() == $user->id_user)) {
				$this->mailToGroupMember($_CB_framework->myId(), $user->id_user, $gid, $body, $subject);
			}
			}
			$_CB_framework->redirect( 'index.php?option=com_groupjive'
				. '&amp;action=gj.core.groups.showgroup&amp;Itemid='.$Itemid.'&amp;groupid='.$gid, GJ_MAILS_WERE_SENT );
		}
	}


	function mailToGroupMember($fromId, $toId, $groupId, $body, $subject) {
		global $_CB_database, $gjConfig;
		$from = new mosUser($_CB_database);
		$from->load($fromId);

		$to = new mosUser($_CB_database);
		$to->load($toId);

		// realnames or nickname
		if( $gjConfig['real_names'] ) {
			$fromname = $from->name;
		} else {
			$fromname = $from->username;
		}
		return gjMail( $from->email, $fromname, $to->email, $subject, $body);
	}
}
?>
