<?php
/**
* @version $Id: search.php
* @package Joomla!
* @subpackage GroupJive
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
* @Joomla! is Free Software
* @author Joshua Holmes
* @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
*/

/**
 * Search functions
 */
// defines
defined( '_VALID_MOS' ) or defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

class search_controller extends groupjive_controller{

	function search_controller( $option=null, $task=null, $parameters=array(), $ItemId ) {
		$this->groupjive_controller( $option, $task, $parameters, $ItemId );
	}

	function searchgroup($searchstring = null) {
		global $_CB_database, $_CB_framework, $gjConfig;

		if (!$searchstring) {
			$searchstring = cbGetParam($_REQUEST, 'searchstring');
		}

		$_CB_framework->appendPathWay(GJ_SEARCH);
	
		$searchstring = strtolower($searchstring);
		//Beware of SQL injection
		$searchstring = escapeString($searchstring);
		$q = "SELECT COUNT(*) FROM #__gj_groups a"
			. "\n INNER JOIN #__gj_grcategory b"
			. "\nON a.category = b.id"
			. "\nWHERE b.access <= ".$_CB_framework->myCmsGid()
			. "\nAND (LCASE(a.name) LIKE '%$searchstring%' "
			. "OR LCASE(a.descr) LIKE '%$searchstring%') "
			. "AND a.active='1' ORDER BY a.name";
	
		$_CB_database->setQuery($q);
	
		$count = $_CB_database->loadResult();
	
		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return false;
		}
	
		$limit = intval(cbGetParam( $_REQUEST, 'limit', $gjConfig['onpage'] ));
		$limitstart = intval(cbGetParam( $_REQUEST, 'limitstart', 0 ));

		cbImport('cb.pagination');
		$pageNav = new cbPageNav( $count, $limitstart, $limit  );
	
		if ($count == 0) {
			HTML_wg::errorpage(GJ_NO_RESULTS, 'info');
			return;
		}
	
	
		//Now get the right records depending on the page...
		
	
		$sql = "SELECT a.id,a.name,a.type,"
			. "\nDATE_FORMAT(date_s, '".$gjConfig['date_form']."') AS date_s,a.descr, a.logo, a.user_id, COUNT(c.id) AS groupusercount "
			. "\nFROM #__gj_groups a"
			. "\n INNER JOIN #__gj_grcategory b"
			. "\nON a.category = b.id"
			. "\nINNER JOIN #__gj_users c"
			. "\nON a.id = c.id_group"
			. "\nWHERE b.access <= ".$_CB_framework->myCmsGid()
			. "\nAND b.published=1"
			. "\nAND (LCASE(a.name) LIKE '%$searchstring%'"
			. "\nOR LCASE(a.descr) LIKE '%$searchstring%') AND a.active='1'"
			. "\nGROUP BY a.id, a.name, a.type, a.date_s, a.descr, a.logo, a.user_id"
			. "\nORDER BY a.name"
			. "\nLIMIT " . (int) $pageNav->limitstart . ", " . (int) $pageNav->limit;
	
		$_CB_database->setQuery($sql);
		$rows=$_CB_database->loadAssocList();	

		if ($_CB_database->getErrorNum()) {
			echo $_CB_database->stderr();
			return false;
		}

		HTML_wg::showmenu();
		HTML_wg::errorpage(GJ_SEARCH_RESULTS.' : '.$searchstring, 'info');
		HTML_wg::showcat($rows, false, $pageNav, $searchstring);
	}
}
?>
