<?PHP
/**
 * gjPatTemplate modifier that quotes LaTeX special chars
 *
 * $Id: QuoteLatex.php 355 2005-01-03 15:56:52Z schst $
 *
 * @package		gjPatTemplate
 * @subpackage	Modifiers
 * @author		Stephan Schmidt <schst@php.net>
 */

/**
 * gjPatTemplate modifier that quotes LaTeX special chars
 *
 * This is useful when creating PDF documents with gjPatTemplate
 *
 * @package		gjPatTemplate
 * @subpackage	Modifiers
 * @author		Stephan Schmidt <schst@php.net>
 * @link		http://www.php.net/manual/en/function.strftime.php
 */
class gjPatTemplate_Modifier_QuoteLatex extends gjPatTemplate_Modifier
{
    /**
     *
     *
     */
    var $_chars = array(
                        '%' => '\%',
                        '&' => '\&',
                        '_' => '\_',
                        '$' => '\$'
                    );
    
   /**
	* modify the value
	*
	* @access	public
	* @param	string		value
	* @return	string		modified value
	*/
	function modify( $value, $params = array() )
	{
	    return strtr($value, $this->_chars);
	}
}
?>