<?php
/**
* @version $Id: groupjive.class.php
* @package Joomla!
* @subpackage GroupJive
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
* @Joomla! is Free Software
* @author Joshua Holmes
* @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
*/

defined( '_VALID_MOS' ) or defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

global $mainframe;

if ( defined( 'JPATH_ADMINISTRATOR' ) ) {
	$pluginclass		= JPATH_ADMINISTRATOR . '/components/com_comprofiler/plugin.class.php';
} else {
	$pluginclass		= $mainframe->getCfg( 'absolute_path' ) . '/administrator/components/com_comprofiler/plugin.class.php';
}

require_once( $pluginclass );

class groupJiveCategory extends comprofilerDBTable {
	var $id = null;
	var $catname = null;
	var $published  = null;
	var $type = null;
	var $admin = null;
	var $create_open = null;
	var $create_closed = null;
	var $create_invite = null;
	var $cat_image = null;
	var $ordering = null;
	/** @var int */
	var $access = null;
	var $descr = null;

	function groupJiveCategory(&$db) {
		$this->comprofilerDBTable('#__gj_grcategory', 'id', $db);
	}
}

class groupJiveGroup extends comprofilerDBTable {
	var $id = null;
	var $name = null;
	var $descr  = null;
	var $date_s = null;
	var $type = null;
	var $creator = null;
	var $user_id = null;
	var $active = null;
	var $category = null;
	var $logo = null;


	function groupJiveGroup(&$db)	{
		$this->comprofilerDBTable('#__gj_groups', 'id', $db);
	}

	function check() {
		if (is_object( $this )) {
			if ($this->category == '') {
				$this->_error = get_class( $this )."::check failed ".GJ_NO_CAT_SELECTED;
				return false;
			}
			if ($this->name == '') {
				$this->_error = get_class( $this )."::check failed ".GJ_NO_GROUPNAME;
				return false;
			}
			if (!$this->creator || $this->user_id == 0) {
				$this->_error = get_class( $this )."::check failed ".GJ_NO_ADMIN;
				return false;
			}
			return true;
		} else {
			return false;
		}
	}

	function getArray($group) {
		$sql = "SELECT a.id AS groupid, b.id AS catid, a.*, b.*"
			. "\nFROM #__gj_groups a"
			. "\nINNER JOIN #__gj_grcategory b"
			. "\nON a.category = b.id"
			. "\nWHERE a.id = ".$group;
		$this->_db->setQuery($sql);
		$result = $this->_db->loadAssocList();
		if ($this->_db->getErrorNum()) {
			$this->_error = $this->_db->stderr();
			return false;
		}
		$this->asArray = $result;
	}

	function getUsersOfGroup() {
		$sql = "SELECT *"
			. "\nFROM #__gj_users"
			. "\nWHERE id_group = $this->id";
		$this->_db->setQuery($sql);
		$result = $this->_db->loadObjectList();
		if ($this->_db->getErrorNum()) {
			$this->_error = $this->_db->stderr();
			return false;
		}
		$this->users = $result;
		return true;
	}

	function deleteAll() {
		global $_PLUGINS;

		$this->_db->setQuery("DELETE FROM #__gj_bul WHERE group_id='$this->id'");
		if (!$result=$this->_db->query()) {
			$this->_error = $this->_db->stderr();
			return false;
		};

		$this->_db->setQuery("DELETE FROM #__gj_active WHERE groups='$this->id'");
		if (!$result=$this->_db->query()) {
			$this->_error = $this->_db->stderr();
			return false;
		};
	
		$this->_db->setQuery("DELETE FROM #__gj_users WHERE id_group='$this->id'");
		if (!$result=$this->_db->query()) {
			$this->_error = $this->_db->stderr();
			return false;
		};
	
		$this->_db->setQuery("DELETE FROM #__gj_groups WHERE id='$this->id'");
		if (!$result=$this->_db->query()) {
			$this->_error = $this->_db->stderr();
			return false;
		};
	

		$_PLUGINS->trigger( 'gj_onAfterDeleteGroup', array( &$this, true ) );

/*		if(EVENTLIST) {
			$this->_db->setQuery("DELETE FROM #__eventlist_categories WHERE catname='$this->name'");
			if (!$result=$this->_db->query()) {
				$this->_error = $this->_db->stderr();
				return false;
			}
			
			$this->_db->setQuery("DELETE FROM #__gj_eventlist WHERE group_id='$this->id'");
			if (!$result=$this->_db->query()) {
			  $this->_error = $this->_db->stderr();
			  return false;
			}
			
		}
*/
		return true;
	}
}


class groupJiveUser extends comprofilerDBTable {
	var $id = null;
	var $id_user = null;
	var $username = null;
	var $id_group = null;
	var $date = null;
	var $status = null;

	function groupJiveUser($db) {
		$this->comprofilerDBTable('#__gj_users', 'id', $db);
	}

	function getUserObject ($uid, $group) {
		$sql = "SELECT id"
			. "\nFROM #__gj_users"
			. "\nWHERE id_user = $uid"
			. "\nAND id_group = $group";

		$this->_db->setQuery($sql);
		$id = $this->_db->loadResult();
		if ($this->_db->getErrorNum()) {
			$this->_error = $this->_db->stderr();
			return false;
		}
		$idObj = $this->load($id);
		return $idObj; 
	}

	function getGroupsOfUser($uid) {
		$sql = "SELECT *"
			. "\nFROM #__gj_users"
			. "\nWHERE id_user = $uid";
		$this->_db->setQuery($sql);
		$result = $this->_db->loadAssocList;
		if ($this->_db->getErrorNum()) {
			$this->_error = $this->_db->stderr();
			return false;
		}
		return $result;
	}

	function changeUserState($state='undefined'){
		if ($this->status != $state) {
			$this->status = $state;
			return $this->store();
		} else {
			$this->_error = GJ_ERROR_STATUS_ALREADY_SET;
			return false;
		}
	}
}

class groupJiveOptions extends comprofilerDBTable {
	var $id = null;
	var $onpage = null;
	var $onpage_members = null;
	var $bul_creator = null;
	var $blogm = null;
	var $nophoto  = null;
	var $nophoto_logo  = null;
	var $approval  = null;
	var $admin_email  = null;
	var $create_open = null;
	var $send_admin_emails  = null;
	var $real_names = null;
	var $create_groups  = null;
	var $notify = null;
	var $notifyjoin = null;
	var $nonreg = null;
	var $version = null;
	var $logosize = null;
	var $pms = null;
	var $date_form = null;
	var $jb = null;
	var $jb_cat = null;
	var $eventlist = null;
	var $bulletin = null;
	var $jomcomment = null;
	var $wysiwyg = null;
	var $wysiwyg_width = null;
	var $wysiwyg_height = null;
	var $wysiwyg_rows = null;
	var $wysiwyg_cols = null;
	var $ajax_active = null;
	var $ajax_access = null;
	var $ajax_message = null;
	var $template = null;
	var $hideprivate = null;
	var $jb_count = null;
	var $el_count = null;  
        var $force_invite = null;
        

	function groupJiveOptions(&$db) {
		$this->comprofilerDBTable('#__gj_options', 'id', $db);
	}
	function getAll(){
	// needs some error handling
		$this->load(1);
		$params = array();
		foreach ($this as $key=>$value) {
                    $params[$key] = $value;
		}
		return $params;
	}
}

class groupJiveBulletin extends comprofilerDBTable {
	var $id = null;
	var $group_id = null;
	var $author_name = null;
	var $author_id = null;
	var $post = null;
	var $subject = null;
	var $date_bul = null;

	function groupJiveBulletin($db) {
		$this->comprofilerDBTable('#__gj_bul', 'id', $db);
	}
}

// taken from CB groupjiveHTML
class groupjiveHTML {


	/**
	 * Creates an option for a list, a multicheckbox field, or a radio field
	 *
	 * @param  string  $value       value of the selection
	 * @param  string  $text        text of the selection
	 * @param  string  $valueName   name of the value variable
	 * @param  string  $textName    name of the text variable
	 * @return stdClass             selection object
	 */
	function makeOption( $value, $text = '', $valueName = 'value', $textName = 'text' ) {
		$option					=	new stdClass;
		$option->$valueName		=	$value;
		$option->$textName		=	trim( $text ) ? $text : $value;
		return $option;
	}
	/**
	 * Creates an optgroup for a list
	 *
	 * @param  string  $text        text of the selection (if NULL: end of optgroup)
	 * @param  string  $valueName   name of the value variable
	 * @param  string  $textName    name of the text variable
	 * @return stdClass             selection object
	 */
	function makeOptGroup( $text = '', $valueName = 'value', $textName = 'text' ) {
		$option					=	new stdClass;
		$option->$valueName		=	( $text !== null ? array( 'optgroup' ) : array( '/optgroup' ) );
		$option->$textName		=	trim( $text ); 
		return $option;
	}
	function radioListArr( &$arr, $tag_name, $tag_attribs, $key, $text, $selected, $required=0 ) {
		reset( $arr );
		$html = array();
		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
			$k = /* stripslashes */ ($arr[$i]->$key);
			$t = /* stripslashes */ ($arr[$i]->$text);
			if ( isset($arr[$i]->id) ) {
				$id = $arr[$i]->id;
			} else {
				$id = str_replace( array( '[', ']'), array( '_', '_' ), $tag_name ) . $i;
			}
			$extra = " id=\"" . $id . "\"";

			if (is_array( $selected )) {
				foreach ($selected as $obj) {
					if ( is_object( $obj ) ) {
						$k2		=	/* stripslashes */ $obj->$key;
					} else {
						$k2		=	$obj;
					}
					if ($k == $k2) {
						$extra .= " checked=\"checked\"";
						break;
					}
				}
			} else {
				$extra .= ($k == /* stripslashes */ ($selected) ? "  checked=\"checked\"" : '');
			}
			if ( $required && ( $i == 0 ) ) {
				$isReq="mosReq=\"".$required."\"";
			} else {
				$isReq="";
			}
			$html[] = "<input type=\"radio\" name=\"$tag_name\" $isReq $tag_attribs value=\"" . htmlspecialchars( $k ) . "\"$extra />&nbsp;<label for=\"" . $id . "\">" . getlangdefinition($t) . "</label>";
		}
		return $html;
	}
	function radioList( &$arr, $tag_name, $tag_attribs, $key, $text, $selected, $required = 0 ) {
		return "\n\t".implode("\n\t ", groupjiveHTML::radioListArr( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $required ))."\n";
	}
	function radioListTable( &$arr, $tag_name, $tag_attribs, $key, $text, $selected, $cols=0, $rows=1, $size=0, $required=0 ) {
		$cellsHtml = groupjiveHTML::radioListArr( $arr, $tag_name, $tag_attribs, $key, $text, $selected, $required );
		return groupjiveHTML::list2Table( $cellsHtml, $cols, $rows, $size );
	}
	function selectList( &$arr, $tag_name, $tag_attribs, $key, $text, $selected, $required = 0 ) {
		reset( $arr );
		$id_name				=	groupjiveHTML::htmlId( $tag_name );
		$html	=	"\n"
				.	'<select name="' . htmlspecialchars( $tag_name ) . '" id="' . htmlspecialchars( $id_name ) . '" ' . $tag_attribs . '>';
		$addBlank				=	( ( ! $required ) && ! ( isset( $arr[0] ) && $arr[0]->$key == '' ) );
		if ( $addBlank ) {
			$html .= "\n\t<option value=\"\"> </option>";
		}

		for ( $i = 0, $n = count( $arr ); $i < $n; $i++ ) {
			$t					=	/* stripslashes */ ($arr[$i]->$text);
			$id					=	isset($arr[$i]->id) ? $arr[$i]->id : null;

			$extra				=	'';
			if ( $id ) {
				$extra			.=	' id="' . $arr[$i]->id . '"';
			}
			if ( is_array( $arr[$i]->$key ) ) {
				$a					=	$arr[$i]->$key;
				if ( $a[0] == 'optgroup' ) {
					$html			.=	"\n  <optgroup label=\"" . htmlspecialchars( $t ) . "\"$extra>";
				} else {
					$html			.=	"\n  </optgroup>";
				}
			} else {
				$k					=	/* stripslashes */ ($arr[$i]->$key);
				if ( is_array( $selected ) ) {
					foreach ( $selected as $obj ) {
						if ( is_object( $obj ) ) {
							$k2		=	$obj->$key;
						} else {
							$k2		=	$obj;
						}
						if ( $k === $k2 ) {
							$extra	.=	' selected="selected"';
							break;
						}
					}
				} else {
					if ( $k == /* stripslashes */ ( $selected ) ) {
						$extra		.=	' selected="selected"';
					}
				}
				$html				.=	"\n\t<option value=\"" . htmlspecialchars( $k ) . "\"$extra>";
				$html				.=	/* &nbsp; of userGroups: cannot do this: htmlspecialchars( */ getlangdefinition( $t );
				$html				.=	"</option>";

			}

		}
		$html					.=	"\n</select>\n";
		return $html;
	}
	function yesnoSelectList( $tag_name, $tag_attribs, $selected, $yes = _UE_YES, $no = _UE_NO ) {
		$arr = array(	groupjiveHTML::makeOption( '0', $no ),
						groupjiveHTML::makeOption( '1', $yes )
					);
		return groupjiveHTML::selectList( $arr, $tag_name, $tag_attribs, 'value', 'text', $selected, 2 );
	}
	function checkboxListArr( &$arr, $tag_name, $tag_attribs,  $key='value', $text='text',$selected=null, $required=0  ) {
		reset( $arr );
		$html = array();
		for ($i=0, $n=count( $arr ); $i < $n; $i++ ) {
			$k = $arr[$i]->$key;
			$t = $arr[$i]->$text;
			if ( isset($arr[$i]->id) ) {
				$id = $arr[$i]->id;
			} else {
				$id = str_replace( array( '[', ']'), array( '_', '_' ), $tag_name ) . $i;
			}
			$extra = " id=\"" . $id . "\"";

			if (is_array( $selected )) {
				foreach ($selected as $obj) {
					if ( is_object( $obj ) ) {
						$k2		=	$obj->$key;
					} else {
						$k2		=	$obj;
					}
					if ($k === $k2) {
						$extra	.=	" checked=\"checked\"";
						break;
					}
				}
			} else {
				$extra .= ($k == $selected ? " checked=\"checked\"" : '');
			}
			if ( $required && ( $i == 0 ) ) {
				$isReq="mosReq=\"".$required."\"";
			} else {
				$isReq="";
			}
			$html[] = "<input type=\"checkbox\" name=\"$tag_name\" $isReq value=\"".$k."\"$extra $tag_attribs /> <label for=\"" . $id . "\">" . getlangdefinition($t) . "</label>";
		}
		return $html;
	}
	function checkboxList( &$arr, $tag_name, $tag_attribs,  $key='value', $text='text',$selected=null, $required=0 ) {
		return "\n\t".implode("\n\t", groupjiveHTML::checkboxListArr( $arr, $tag_name, $tag_attribs,  $key, $text,$selected, $required ))."\n";
	}
	function checkboxListTable( &$arr, $tag_name, $tag_attribs,  $key='value', $text='text',$selected=null, $cols=0, $rows=0, $size=0, $required=0 ) {
		$cellsHtml = groupjiveHTML::checkboxListArr( $arr, $tag_name, $tag_attribs,  $key, $text,$selected, $required );
		return groupjiveHTML::list2Table( $cellsHtml, $cols, $rows, $size );
	}
	// private methods:
	function list2Table ( $cellsHtml, $cols, $rows, $size ) {
		$cells					=	count( $cellsHtml );

		$size					=	(int) ( ( $size - ( $size % 3 ) ) / 3  ) * 2;	// int div  3 * 2 width/heigh ratio
		if ( $size == 0 ) {
			$localstyle			=	'';		//" style='width:100%'";
		} else {
			$localstyle			=	' style="width:' . $size . 'em;"';
		}
		$return					=	'';
		if ( $cells ) {
			if ( $rows ) {
				$return			=	"\n\t" . '<table class="cbMulti"' . $localstyle . '>';
				$cols			=	( $cells - ( $cells % $rows ) ) / $rows;	// int div
				if ( $cells % $rows ) {
					$cols++;
				}
				$lineIdx		=	0;
				for ( $lineIdx = 0, $n = min( $rows, $cells ) ; $lineIdx < $n ; $lineIdx++ ) {
					$return		.=	"\n\t\t<tr>";
					for ( $i = $lineIdx ; $i < $cells ; $i += $rows ) {
						$return	.=	'<td>' . $cellsHtml[$i] . '</td>';
					}
					$return 	.=	"</tr>\n";
				}
				$return			.=	"\t</table>\n";
			} elseif ( $cols ) {
				$return			=	"\n\t" . '<table class="cbMulti"' . $localstyle . '>';
				$idx			=	0;
				while ( $cells ) {
					$return		.=	"\n\t\t<tr>";
					for ($i=0, $n=min($cells,$cols); $i < $n; $i++, $cells-- ) {
						$return .=	"<td>".$cellsHtml[$idx++]."</td>";
					}
					$return		.=	"</tr>\n";
				}
				$return			.=	"\t</table>\n";
			} else {
				$return			=	"\n\t" . implode( "\n\t ", $cellsHtml ) . "\n";
			}
		}
		return $return;
	}
	/**
	 * Returns a validating unique id attribute based on name attribute
	 *
	 * @param  string  $name
	 * @return string
	 */
	function htmlId( $name ) {
		return str_replace( array( '[', ']' ), array( '__', '' ), $name );
	}
	/**
	* simple Javascript Cloaking
	* email cloacking
 	* by default replaces an email with a mailto link with email cloacked
	*/
	function emailCloaking( $mail, $mailto=1, $text='', $email=1, $cloaktext=true ) {
		// convert text
		$mail 		= groupjiveHTML::encoding_converter( $mail );
		// split email by @ symbol
		$mail		= explode( '@', $mail );
		if ( count( $mail ) > 1 ) {
			$mail_parts	= explode( '.', $mail[1] );
		} else {
			$mail_parts	=	array( '' );
		}
		// random number
		$rand	= rand( 1, 100000 );

		$replacement 	= "\n<script language='JavaScript' type='text/javascript'> \n";
		$replacement 	.= "<!-- \n";
		$replacement 	.= "var prefix = '&#109;a' + 'i&#108;' + '&#116;o'; \n";
		$replacement 	.= "var path = 'hr' + 'ef' + '='; \n";
		$replacement 	.= "var addy". $rand ." = '". @$mail[0] ."' + '&#64;' + '". implode( "' + '&#46;' + '", $mail_parts ) ."'; \n";
		if ( $mailto ) {
			// special handling when mail text is different from mail addy
			if ( $text ) {
				if ( $cloaktext ) {
					if ( $email ) {
						// convert text
						$text 	= groupjiveHTML::encoding_converter( $text );
						// split email by @ symbol
						$text 	= explode( '@', $text );
						$text_parts	= explode( '.', $text[1] );
						$replacement 	.= "var addy_text". $rand ." = '". @$text[0] ."' + '&#64;' + '". implode( "' + '&#46;' + '", @$text_parts ) ."'; \n";
					} else {
						$text 	= groupjiveHTML::encoding_converter( $text );
						$replacement 	.= "var addy_text". $rand ." = '". $text ."';\n";
					}
				} else {
					$replacement	.=	"var addy_text". $rand ." = '". $text ."'; \n";
				}
				$replacement 	.= "document.write( '<a ' + path + '\'' + prefix + ':' + addy". $rand ." + '\'>' ); \n";
				$replacement 	.= "document.write( addy_text". $rand ." ); \n";
				$replacement 	.= "document.write( '<\/a>' ); \n";
			} else {
				$replacement 	.= "document.write( '<a ' + path + '\'' + prefix + ':' + addy". $rand ." + '\'>' ); \n";
				$replacement 	.= "document.write( addy". $rand ." ); \n";
				$replacement 	.= "document.write( '<\/a>' ); \n";
			}
		} else {
			$replacement 	.= "document.write( addy". $rand ." ); \n";
		}
		$replacement 	.= "//--> \n";
		$replacement 	.= "</script> \n";
		$replacement 	.= "<noscript> \n";
		$replacement 	.= _UE_CLOAKED;
		$replacement 	.= "\n</noscript> \n";

		return $replacement;
	}

	function encoding_converter( $text ) {
		// replace vowels with character encoding
		$text 	= str_replace( 'a', '&#97;', $text );
		$text 	= str_replace( 'e', '&#101;', $text );
		$text 	= str_replace( 'i', '&#105;', $text );
		$text 	= str_replace( 'o', '&#111;', $text );
		$text	= str_replace( 'u', '&#117;', $text );

		return $text;
	}


	/**
	* @param int The row index
	* @param int The record id
	* @param boolean
	* @param string The name of the form element
	* @return string
	*/
	function idBox( $rowNum, $recId, $checkedOut=false, $name='cid' ) {
		if ( $checkedOut ) {
			return '';
		} else {
			return '<input type="checkbox" id="cb'.$rowNum.'" name="'.$name.'[]" value="'.$recId.'" onclick="isChecked(this.checked);" />';
		}
	}

	/**
	* Utility function to provide ToolTips
	* @param int user interface : 1: frontend, 2: backend (not used anymore
	* @param string ToolTip text
	* @param string Box title
	* @returns HTML code for ToolTip
	*/
	function gj_mosToolTip( $ui, $tooltip, $title='', $width='', $image='tooltip.png', $htmltext='', $href='', $style='', $olparams='',$click=false, $altText=' ' ) {
		global $_CB_framework;
		if ( $altText == ' ' ) {
			$altText	=	' alt="' . strip_tags( sprintf( _UE_INFORMATION_FOR_FIELD, htmlspecialchars( stripslashes( $title ) ), htmlspecialchars( stripslashes( $tooltip ) ) ) ) . '"';
		}
		if ( $width ) {
			$width = ', WIDTH, \''.$width .'\'';
		}
		if ( $title ){
			$title = ', CAPTION, \''.$title .'\'';
		}
		if ( $olparams ) {
			$olparams = ', '.$olparams;
		}
		if ($click) {
			$tooltipcode = " onclick=\"return overlib('" . str_replace( "\n", ' ', $tooltip ) . "'". $title . $width . $olparams . ");\"";
		} else {
			$tooltipcode = " onmouseover=\"return overlib('" . str_replace( "\n", ' ', $tooltip ) . "'". $title . $width . $olparams . ");\" onmouseout=\"return nd();\"";
		}
		if ( !$htmltext ) {
			if ($image == 'tooltip.png') {
				$style = 'style="border:0" width="16" height="16" title=""';
			}

			$tmpUi = $_CB_framework->getUI();
			$_CB_framework->_ui = 2;
			$live			=	$_CB_framework->getCfg( 'live_site' );
			$_CB_framework->_ui = $tmpUi;

			$image 	= $live.'/components/com_comprofiler/plugin/templates/default/'. $image;
			if ($href) {
				$htmltext = '<img src="'. $image .'" '. $style . $altText . ' />';
			}
		}
		if ( $href ) {
			$tip 	= "<a href=\"". $href . '"' . $tooltipcode . ' ' . $style .">". $htmltext ."</a>";
		} else {
			if ($htmltext) {
				$tip 	= "<span" . $tooltipcode . ' ' . $style . ">" . $htmltext ."</span>";
			} else {
				$tip 	= '<img src="'. $image .'" ' . $style . $altText . $tooltipcode . " />";
			}
		}
		return $tip;
	}

	// $ui is not used anymore:
	function gjFieldTip($ui, $fieldTip, $tipTitle='', $width='', $image='images/mini-icons/icon-16-info.png', $htmltext='', $href='', $style='', $olparams='',$click=false) {
		$altText	=	' alt="' . strip_tags( sprintf( _UE_INFORMATION_FOR_FIELD, htmlspecialchars( $tipTitle ), htmlspecialchars( $fieldTip ) ) ) . '" title=""';
		// overlib_mini does not support newlines:
		if (strpos($fieldTip, "&lt;") === false) {
			$fieldTip = str_replace("\r\n", "&lt;br /&gt;", $fieldTip);	
			$fieldTip = str_replace("\n", "&lt;br /&gt;", $fieldTip);
		} else {
			$fieldTip = str_replace("\r\n", " ", $fieldTip);	
			$fieldTip = str_replace("\n", " ", $fieldTip);
		}
		$fieldTip = str_replace(array('"','<','>',"\\"), array("&quot;","&lt;","&gt;","\\\\"), $fieldTip);
		$tipTitle = str_replace(array('"','<','>',"\\"), array("&quot;","&lt;","&gt;","\\\\"), $tipTitle);
		$fieldTip = str_replace(array("'","&#039;","&#39;"), "\\'", $fieldTip);
		$tipTitle = str_replace(array("'","&#039;","&#39;"), "\\'", $tipTitle);
		return groupjiveHTML::gj_mosToolTip( $ui, $fieldTip, $tipTitle, $width, $image, $htmltext, $href, $style, $olparams, $click, $altText );
	}

	/**
	* Utility function to include ToolTips and set defaults for CB
	* @param int user interface : 1: frontend, 2: backend NOT USED ANYMORE !
	* @param string width of tooltips
	* @returns HTML code for init ToolTip in head section
	*/
	function initToolTip( $ui, $width='250' ) {
		static $outputed	=	false;
		if ( ! $outputed ) {
			global $_CB_framework;

			$tmpUi = $_CB_framework->getUI();
			$_CB_framework->_ui = 2;
			$live			=	$_CB_framework->getCfg( 'live_site' );

			$_CB_framework->_ui = $tmpUi;
			$tip= '<link type="text/css" rel="stylesheet" href="' . $live . '/administrator/components/com_groupjive/gj.admin.css"/>'
			."\n".'<script type="text/javascript" src="' . $live . '/components/com_comprofiler/js/overlib_mini.js"></script>'
			."\n".'<script type="text/javascript" src="' . $live . '/components/com_comprofiler/js/overlib_hideform_mini.js"></script>'
			."\n".'<script type="text/javascript" src="' . $live . '/components/com_comprofiler/js/overlib_anchor_mini.js"></script>'
			."\n".'<script type="text/javascript" src="' . $live . '/components/com_comprofiler/js/overlib_centerpopup_mini.js"></script>'
			."\n".'<script type="text/javascript">'
			.'overlib_pagedefaults(WIDTH,'.$width.',VAUTO,RIGHT,AUTOSTATUSCAP, CSSCLASS,'
			.'TEXTFONTCLASS,\'cb-tips-font\',FGCLASS,\'cb-tips-fg\',BGCLASS,\'cb-tips-bg\''
			.',CAPTIONFONTCLASS,\'cb-tips-capfont\', CLOSEFONTCLASS, \'cb-tips-closefont\');'
			."</script>\n";
			$outputed		=	true;
			return $tip;
		} else {
			return null;
		}
	}

	/**
	 * offsets date-time if time is present and $serverTimeOffset 1, then formats to CB's configured date-time format.
	 *
	 * @param mixed		string $date in "Y-m-d H:i:s" format, or 	int : unix timestamp
	 * @param int $serverTimeOffset : 0: don't offset, 1: offset if time also in $date
	 * @param boolean $showtime : false don't show time even if time is present in string
	 * @return string date formatted 
	 */
	function gjFormatDate( $date, $serverTimeOffset = 1, $showtime = true ) {
		global $ueConfig;
		
		if ( is_int( $date ) ) {
			$date = date( ($showtime) ? "Y-m-d H:i:s" : "Y-m-d", $date );
		}
		if ( ( $date!='' ) && ( $date != null ) && ( $date != '0000-00-00 00:00:00' ) && ( $date != '0000-00-00' ) ) {
			if ( strlen( $date ) > 10 ) {
				if ( ( $serverTimeOffset == 1 ) ) {
					$date = groupjiveHTML::_old_gjFormatDate( $date, (($showtime) ? "%Y-%m-%d %H:%M:%S" : "%Y-%m-%d" ) );		// offsets datetime with server offset setting
				} else {
					$date = substr( $date, 0, 10 );
				}
			}
			$ret = groupjiveHTML::dateConverter( $date, 'Y-m-d', $ueConfig['date_format'] );
		} else {
			$ret = "";
		}
		return $ret;
	}
	
	/**
	* Returns formated date according to current local and adds time offset
	*
	* @param  string  $date    In datetime format
	* @param  string  $format  Optional format for strftime
	* @param  int     $offset  Time offset if different than global one
	* @return string           Formated date
	* @access private
	*/
	function _old_gjFormatDate( $date, $format = "", $offset = null ) {
		global $_CB_framework;
	
		if ( $format == '' ) {
			// %Y-%m-%d %H:%M:%S
			$format		=	defined( '_DATE_FORMAT_LC' ) ? _DATE_FORMAT_LC : ( defined( 'DATE_FORMAT_LC' ) ? DATE_FORMAT_LC : '%Y-%m-%d %H:%M:%S' );
		}
		if ( is_null( $offset ) ) {
			$offset		=	$_CB_framework->getCfg( 'offset' );
		}
		$regs			=	null;
		if ( $date && preg_match( "/([0-9]{4})-([0-9]{2})-([0-9]{2})[ ]([0-9]{2}):([0-9]{2}):([0-9]{2})/", $date, $regs ) ) {
			$date		=	mktime( $regs[4], $regs[5], $regs[6], $regs[2], $regs[3], $regs[1] );
			$date		=	$date > -1 ? strftime( $format, $date + ( $offset * 3600 ) ) : '-';
		}
		return $date;
	}
	function dateConverter($oDate,$oFromFormat,$oToFormat) {
		if($oDate=="" || $oDate == null || !isset($oDate)) {
			return "";
		} else {
			$specChar = array(".","/");
			$oDate = str_replace($specChar,"-",$oDate);
			$oFromFormat = str_replace($specChar,"-",$oFromFormat);
			$oDate=explode(" ",$oDate);
			if (!ISSET($oDate[1])) $oDate[1]="";
			$dateParts=explode ("-", $oDate[0] );
			$fromParts=explode( "-", $oFromFormat );
	
			$dateArray = array();
			$dateArray[$fromParts[0]] = $dateParts[0];
			$dateArray[$fromParts[1]] = $dateParts[1];
			if ( isset( $dateParts[2] ) ) {
				$dateArray[$fromParts[2]] = $dateParts[2];
			}
			if (strpos($oToFormat,"/")!=false) $char = "/";
			elseif (strpos($oToFormat,".")!=false) $char = ".";
			else $char = "-";
	
			$toParts=explode( $char, $oToFormat );
	
			$returnDate					=	$oToFormat;
			foreach ( $toParts as $toPart ) {
				if ( ( $toPart == 'Y' ) || ( $toPart == 'y' ) ) {
					if ( array_key_exists( $toPart, $dateArray ) ) {
						$returnDate		=	str_replace($toPart,$dateArray[$toPart],$returnDate);
					} elseif ( $toPart == 'y' ) {
						$returnDate		=	str_replace($toPart,substr($dateArray['Y'],-2),$returnDate);
					} else {
						$returnDate		=	str_replace($toPart,$dateArray['y'],$returnDate);
					}
				}else {
					$returnDate			=	str_replace($toPart,substr($dateArray[$toPart],0,2),$returnDate);
				}
			}
			return $returnDate. ( ( $oDate[1] != "" ) ? " ". $oDate[1] : "" );
		}
	
	}

}

class groupjiveCommonHTML {

	function ContentLegend( ) {
		?>
		<table cellspacing="0" cellpadding="4" border="0" align="center">
		<tr align="center">
			<td>
			<img src="images/publish_y.png" width="12" height="12" border="0" alt="Pending" />
			</td>
			<td>
			Published, but is <u>Pending</u> |
			</td>
			<td>
			<img src="images/publish_g.png" width="12" height="12" border="0" alt="Visible" />
			</td>
			<td>
			Published and is <u>Current</u> |
			</td>
			<td>
			<img src="images/publish_r.png" width="12" height="12" border="0" alt="Finished" />
			</td>
			<td>
			Published, but has <u>Expired</u> |
			</td>
			<td>
			<img src="images/publish_x.png" width="12" height="12" border="0" alt="Finished" />
			</td>
			<td>
			Not Published
			</td>
		</tr>
		<tr>
			<td colspan="8" align="center">
			Click on icon to toggle state.
			</td>
		</tr>
		</table>
		<?php
	}

	function AccessProcessing( &$row, $i ) {
		if ( !$row->access ) {
			$color_access	= 'style="color: green;"';
			$task_access	= 'accessregistered';
		}
		else if ( $row->access == 1 ) {
			$color_access	= 'style="color: red;"';
			$task_access	= 'accessspecial';
		}
		else {
			$color_access	= 'style="color: black;"';
			$task_access	= 'accesspublic';
		}

		$href = '
		<a href="javascript: void(0);" onclick="return listItemTask(\'cb'. $i .'\',\''. $task_access .'\')" '. $color_access .'>
		'. $row->groupname .'
		</a>'
		;

		return $href;
	}
}

/**
 * Class Controller
 * @package groupjive
 */
class groupjive_controller {
	/** @var string Task */
	var $_task			= null;

	/** @var array Parameters */
	var $_parameters	= array();

	var $_option		= null;

	var $_ItemId		= null;

	/**
	 * Constructor
	 * @param string Task
	 */
	function groupjive_controller ( $option=null, $task=null, $parameters=array(), $ItemId) {
		$this->_task		= $task;
		$this->_parameters	= $parameters;
		$this->_option		= $option;
		$this->_itemId		= $ItemId;
	}

	function setTask($task){
		$this->_task		= $task;
	}

	function run() {
		$this->{$this->_task}();
	}
}


/**
 * Class Template
 * @package groupjive
 */
class groupjive_template {
	/** @var array Blocks */
	var $_blocks = array();

	/**
	* Static method to create the template object
	* @return patTemplate
	*/
	function &createTemplate($template=null) {
		global $option, $gjConfig;

		if (file_exists(GJBASEPATH.'/patTemplate.php')) {
			require_once( GJBASEPATH.'/patTemplate.php' );
		}

		$tmpl =& patFactory::createTemplate( $option, true, false );

		if (file_exists(GJBASEPATH . '/templates/'.$gjConfig['template']. '/'.$template)) {
			$tmpl->setRoot( GJBASEPATH . '/templates/'.$gjConfig['template'] );
		}
		else {
			$tmpl->setRoot( GJBASEPATH . '/templates/default' );
		}

		$tmpl->readTemplatesFromInput($template);
		return $tmpl;
	}	// ---- end &createTemplate -----------------------------------------------

	function groupjive_template () {
		$keys = array('top','bottom','left', 'right', 'topleft', 'topmiddle', 'topright', 'center', 'bottomleft', 'bottommiddle', 'bottomright');
		// cannot use array_fill_keys, cause it is PHP >= 5.2.0
		// $this->_blocks  = array_fill_keys($keys, array());
		$this->_blocks = array_combine($keys,array_fill(0,count($keys), array()));
	}

	function processTemplate() {
		// create skeleton template
		$tmpl =& HTML_wg::createTemplate('skeleton.tmpl');

		// fill in the template vars
		foreach ($this->_blocks as $key => $value) {
			$tmpl->addVar( 'skeleton',  'GJ_'.strtoupper( $key ), implode("\n", $value ));
		}

		// display the template
		$tmpl->displayParsedTemplate( 'skeleton' );
	}

	function addContent ( $content, $block ){
		array_push($this->_blocks[$block], $content);
	}
}

class gjPluginHandler extends cbPluginHandler {
	/**
	* Constructor
	*/
	function gjPluginHandler() {
		$this->cbPluginHandler();
	}
}	// end class gjPluginHandler

?>
