<?php
/**
* @version $Id: groupjive_func.inc
* @package Joomla!
* @subpackage GroupJive
* @license http://www.gnu.org/licenses/old-licenses/gpl-2.0.html GNU/GPL v2
* @Joomla! is Free Software
* @author Joshua Holmes
* @further developed by Anna Tannenberg, John Bultena, Michael Perthel, David Freund, Mark Raborn and Project GroupJive.
*/

defined( '_VALID_MOS' ) or defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );

global $_CB_database, $_CB_framework, $_PLUGINS;

if (!defined('JPATH')) define ('JPATH', $_CB_framework->getCfg('absolute_path'));

$UElanguagePath		=	$_CB_framework->getCfg( 'absolute_path' ) . '/components/com_comprofiler/plugin/language';
$UElanguage			=	$_CB_framework->getCfg( 'lang' );

if ( ! file_exists( $UElanguagePath . '/' . $UElanguage . '/' . $UElanguage . '.php' ) ) {
	$UElanguage		=	'default_language';
}
include_once( $UElanguagePath . '/' . $UElanguage . '/' . $UElanguage . '.php' );

if (file_exists(JPATH.'/components/com_groupjive/language/'.$UElanguage.'/'.$UElanguage.'.php')) {
	include_once(JPATH.'/components/com_groupjive/language/'.$UElanguage.'/'.$UElanguage.'.php');
}
else {
	include_once(JPATH.'/components/com_groupjive/language/english/english.php');
}

global $gjConfig;

require_once(JPATH.'/components/com_groupjive/groupjive.html.php');
require_once(JPATH.'/administrator/components/com_groupjive/groupjive.class.php');
require_once(JPATH.'/administrator/components/com_groupjive/gj_config.php');
require_once(JPATH."/components/com_groupjive/helpers.php");

// we can use this to assign defaults to unknown configuration settings

$options = new groupJiveOptions($_CB_database);
$gj_params = $options->getAll();


// todo remove eventlist from core GJ -> integration plugin
define('_GJ_CONF_COUNT_EVENTS', cbGetParam( $gj_params, 'el_count', 5 ));
define('EVENTLIST', cbGetParam( $gj_params, 'eventlist', 0 ));

define('VERSION',cbGetParam( $gj_params, 'version', 1 ));


//Users without avatars cannot see other users avatars, CBE only
if (file_exists('administrator/components/com_groupjive/enhanced_admin/enhanced_config.php')) {
include_once('administrator/components/com_groupjive/enhanced_admin/enhanced_config.php');
define('PIC2PIC',$enhanced_Config['pic2pic']);
} else {
define('PIC2PIC','0');
}
if (PIC2PIC) {
	$query="SELECT COUNT(id) FROM #__comprofiler WHERE user_id=".$_CB_framework->myId()." AND avatar IS NOT NULL AND avatarapproved='1'";
	$_CB_database->setQuery($query);
  	$mypic = $_CB_database->loadResult();
}

global $pms, $admin;

$pms = cbGetParam( $gj_params, 'pms' );
$logosize = cbGetParam( $gj_params, 'logosize' ). "px";
$date_format = cbGetParam( $gj_params, 'date_form' );
$jb_cat = cbGetParam( $gj_params, 'jb_cat' );

$todo =  cbGetParam( $_REQUEST ,'task', 0 ) ;
$exgroup = intval( cbGetParam( $_REQUEST, 'groupid',0));
$groupname = cbGetParam( $_REQUEST, 'groupname',0);
$_CB_framework->setPageTitle(GJ_TITLE);

// put the stylesheet in the head-section
$csslink = '<link href="'.$_CB_framework->getCfg( 'live_site' ).'/components/com_groupjive/templates/'.$gjConfig['template'].'/groupjive_css.css" rel="stylesheet" type="text/css" />';
//echo 'link:<p>'.$csslink.'<p>';
$_CB_framework->addCustomHeadTag($csslink);

// Permissions: Check for administrators
$admin = 0;
if ($_CB_framework->myId() != 0) {
	$groupname = $_CB_framework->myUserType();
	$admin = (strtolower($groupname) == 'super administrator' || strtolower($groupname) == 'administrator');
}

function main_page($row) {
	global $gjConfig, $_GJ_TEMPLATES;

	$content = '<div id="columnSmall2">';
	$content .= latestmembers($row->id);
	$content .= '</div>';
	if($gjConfig['bulletin']) {
		$content .= '<div id="columnSmall3">';
		$content .=latestbul($row->id);
		$content .= '</div>';
	}
	if(file_exists('components/com_eventlist') && EVENTLIST){
		$content .= '<div id="columnSmall2">';
		$content .= latestEvents($row->id);
		$content .= '</div>';
	}
	$content .= '<div style="clear:both;"></div>';
	$_GJ_TEMPLATES->addContent($content, 'center');
}

function moderator_func($row) {
  global $Itemid, $gjConfig;

  $mod = '<ul id="func-inc_moderator_func"><li><a href="'
          . cbSef("index.php?option=com_groupjive&"
          . "action=gj.core.members.showinactiveusers&amp;groupid=$row->id&amp;Itemid=$Itemid")
          . '">'.GJ_INACTIVE_USERS.'</a></li>'

          . '<li><a href="'
          . cbSef("index.php?option=com_groupjive&"
          . "action=gj.core.groups.editgroup&amp;groupid=$row->id&amp;Itemid=$Itemid")
          . '">'.GJ_EDIT_GROUP_INFO.'</a></li>'

          . '<li><a href="'
          . cbSef("index.php?option=com_groupjive&"
          . "action=gj.core.mail.mailgroupmembers&amp;groupid=$row->id&amp;Itemid=$Itemid")
          . '">'.GJ_MAIL_GROUP.'</a></li>';

	if ( $gjConfig['delete_groups'] ) {
		$mod .= '<li><a href="'
				. cbSef("index.php?option=com_groupjive&"
				. "action=gj.core.groups.deletegroup&amp;groupid=$row->id&"
				. "Itemid=$Itemid")
				. "\" onclick=\"return confirm('".GJ_DELETE_G_CONFIRM."')\">"
				. GJ_DELETE_GROUP.'</a></li></ul>';
	}

	return $mod;
}

function group_info($row) {
  global $_CB_framework, $gjConfig;
	// $date = date($date_format, $row->date_s);
	$info = '<ul id="func-inc_group_info">';

	if(!empty($row->descr)) {
	 $info .= '<li><strong>'.GJ_GROUPDESCR.'</strong>:&nbsp;'
            . stripslashes($row->descr).'</li>';
	}

	$info .= '<li><strong>'.GJ_TYPE.':&nbsp;</strong>';

	switch($row->type) {
		case 1:
		{
			$info .= GJ_OPEN;
			break;
		}
		case 2:
		{
			$info .= GJ_APREQUIRED;
			break;
		}
		case 3:
		{
			$info .= GJ_PRIVATE;
			break;
		}
	}

	 if( $gjConfig['real_names'] ) {
    $creator = $row->name;
    } else {
    $creator = $row->username;
	 }

	$info .='</li><li><strong>'.GJ_FOUNDED.'</strong>:&nbsp;'
            . $row->date_s.'</li><li><strong>'.GJ_MEMBERS.'</strong>:&nbsp;'
            . groupusercount($row->id).'</li>'
            . '<li><strong>'.GJ_CREATOR.'</strong>:&nbsp;'.$creator;

	$info .= '</li></ul>';
	return $info;
}


function links($row) {
	global $jb_cat, $Itemid, $gjConfig, $_PLUGINS;

	$links = '<ul id="func-inc_function_links"><li>'
		. '<a href="'
		. cbSef("index.php?option=com_groupjive&"
		. "action=gj.core.members.showmemberlist&amp;groupid=$row->id&amp;Itemid=$Itemid")
		. '">'.GJ_MEMBERS.'</a></li>';

	if ($gjConfig['bulletin']){
	$links .= '<li><a href="'
		. cbSef("index.php?option=com_groupjive&"
		. "action=gj.core.bulletin.showbulletin&amp;groupid=$row->id&"
		. "Itemid=$Itemid").'">'.GJ_GROUP_BUL.'</a></li>';
	}

	if(EVENTLIST) {
		$links .= '<li><a href="'
			. cbSef("index.php?option=com_eventlist&"
			. "func=shcatev1&categid=$row->category_id_el&"
			. "Itemid=$Itemid").'">'.GJ_GROUP_EVENT.'</a></li>';
	}

	$pluginLinks = $_PLUGINS->trigger('gj_onBeforeShowLinks', array($row));

	$links 		.= implode("\n", $pluginLinks);

	$links .= '<li><a href="'
		. cbSef("index.php?option=com_groupjive&amp;action="
		. "gj.core.groups.showgroup&amp;groupid=$row->id&amp;Itemid=$Itemid")
		. '">'.GJ_BACKTGROUP.'</a></li></ul>';

	return $links;
}



function checkuser($groupid,$userid) {
	global $_CB_database;

	$query="SELECT COUNT(*) FROM #__gj_users "
		. "WHERE id_user='$userid' "
		. "AND id_group='$groupid' "
		. "AND status IN ('active', 'need approval')";

	$_CB_database->setQuery($query);
	if(!$result=$_CB_database->query()) {
		echo $_CB_database->stderr();
		return;
	}

	$exist = $_CB_database->loadResult();
	if (!$exist==0) {
		return 1;
	}
	else {
		return 0;
	}
}

function checkuseractive($groupid,$userid) {
	global $_CB_database;

	$query="SELECT COUNT(*) FROM #__gj_users "
		. "WHERE id_user='$userid' "
		. "AND id_group='$groupid' "
		. "AND status='active'";
	$_CB_database->setQuery($query);
	if(!$result=$_CB_database->query()) {
		echo $_CB_database->stderr();
		return;
	}

	$exist = $_CB_database->loadResult();
	if (!$exist==0) {
		return 1;
	}
	else {
		return 0;
	}
}


function ismoder($groupid,$userid) {
	//Check to see if the user viewing is the moderator
	global $_CB_database;
	$query="SELECT COUNT(*) FROM #__gj_groups "
          . "WHERE id='$groupid' "
          . "AND user_id='$userid'";
	$_CB_database->setQuery($query);
	if(!$result=$_CB_database->query()) {
		echo $_CB_database->stderr();
		return;
	}

	$exist = $_CB_database->loadResult();
	if (!$exist==0)
		return 1;
	else return 0;
}

function groupusercount($groupid) {
  // Here is where I find out how many members are in a group
	//for display on the category pages
	global $_CB_database;
	$query="SELECT COUNT(*) FROM #__gj_users "
          . "WHERE id_group='$groupid' "
          . "AND status='active'";
  $_CB_database->setQuery($query);
	if(!$result=$_CB_database->query()) {
		echo $_CB_database->stderr();
		return;
	}
	$usercount= $_CB_database->loadResult();

	//return the user count for group
	return $usercount;
}

function latestmembers($gid) {
	global $_CB_database, $_CB_framework, $mypic, $gjConfig ;

	$query="SELECT b.name, b.username, b.id, c.avatar "
		. "FROM #__gj_users AS a INNER JOIN #__users AS b "
		. "ON a.id_user = b.id "
		. "INNER JOIN #__comprofiler AS c "
		. "ON b.id = c.user_id "
		. "WHERE a.id_group ='".$gid
		. "' AND a.status = 'active' ORDER BY a.date DESC LIMIT 3";

	$_CB_database->setQuery($query);

	if(!$result=$_CB_database->query()) {
		return $_CB_database->stderr();
	}

	$rows=$_CB_database->loadObjectList();

	$content = "<h3 class=\"componentheading\">".GJ_NEWESTMEM."</h3>";
	$content .= "<ul id=func-inc_newest_member>";

	foreach ($rows as $row) {
		if( $gjConfig['real_names'] ) {
			$name = $row->name;
		}
		else {
			$name = $row->username;
		}

		if (file_exists("images/comprofiler/tn".$row->avatar) && (!PIC2PIC || (PIC2PIC && $mypic))) {
			$im="images/comprofiler/tn".$row->avatar;
		}
		else if( file_exists('images/comprofiler/tn'.$row->avatar) && PIC2PIC && !$mypic) {
			if (file_exists('components/com_comprofiler/images/'.$_CB_framework->getCfg( 'lang' ).'/tnnophoto.jpg')) {
				$im='components/com_comprofiler/images/'.$_CB_framework->getCfg( 'lang' ).'/tnnophoto.jpg';
			}
			else {
				$im='components/com_comprofiler/images/english/tnnophoto.jpg';
			}
		}
		else if (substr($row->avatar, 0, 7) == 'gallery' && file_exists("images/comprofiler/".$row->avatar)) {
			$im="images/comprofiler/".$row->avatar;
		}
		else {
			$im = $gjConfig['nophoto'];
		}

		$content .= "<li><img src=\"$im\" alt=\"$name\" /><br />"
			. "<a href=\""
			. cbSef("index.php?option=com_comprofiler&"
			. "task=userProfile&amp;user=$row->id")."\">"
			. $name."</a></li>";
	}
	$content .= "</ul>";
	return $content;
}

function latestEvents($gid) {
	global $_CB_database, $Itemid;
	// check if EventList is installed
	if (!file_exists('components/com_eventlist') || !EVENTLIST) {
		return;
	}

	$query = "SELECT a.id AS did, a.catsid, a.titel, a.deliverdate, a.sendername, c.id AS userid FROM #__eventlist_dates AS a"
		."\nINNER JOIN #__gj_eventlist AS b"
		."\nON a.catsid = b.category_id"
		."\nINNER JOIN #__users AS c"
		."\nON a.sendername = c.username"
		."\nWHERE b.group_id = $gid"
		."\nORDER BY a.deliverdate DESC"
		."\nLIMIT "._GJ_CONF_COUNT_EVENTS;

	$_CB_database->setQuery($query);

	if(!$result=$_CB_database->query()) {
		return $_CB_database->stderr();
	}

	$rows=$_CB_database->loadObjectList();
	$total=count($rows);

	$content = "<h3 class=\"componentheading\">".GJ_LATEST_EVENTS."</h3>";
	$content .= "<ul id=func-inc_latest_forum>";

	if($total > 0) {
		foreach ($rows as $row) {
			$content .= "<li><a href=\""
				. cbSef("index.php?option=com_eventlist&amp;"
				. "func=details&amp;Itemid=$Itemid&amp;did=".$row->did."&amp;categid="
				. $row->catsid)
				. "\">".$row->titel."</a><br /><small>"
				. GJ_BY."&nbsp;<a href=\""
				. cbSef("index.php?option=com_comprofiler&amp;"
				. "task=userProfile&amp;user=".$row->userid)."\">"
				. $row->sendername.'</a>&nbsp;('.date('Y-m-d', $row->deliverdate).')</small></li>';
		}
		$content .= "</ul>";
	}
	else {
		$content .= GJ_NO_EVENTS;
	}
}

function latestbul($gid) {
	global $_CB_database, $Itemid, $gjConfig;

	$content = "<h3 class=\"componentheading\">".GJ_LATESTBULLETIN."</h3>";
	$query="SELECT a.*";

	if( $gjConfig['real_names'] ) {
		$query .= ", b.name AS author_name";
	}

	$query .= " FROM #__gj_bul AS a INNER JOIN #__users AS b "
		. "ON a.author_id = b.id "
		. "WHERE a.group_id='$gid' "
		. "ORDER BY date_bul DESC LIMIT 1";

	$_CB_database->setQuery($query);

	if(!$result=$_CB_database->query()) {
		$content =  $_CB_database->stderr();
		return $content;
	}

	$result=$_CB_database->loadObjectList();
	$total=count($result);
	if($total > 0) {
		$row=$result[0];
		$content .= "<h4><a href=\"index.php?option=com_groupjive&amp;action=gj.core.bulletin.showfullmessage&idm=$row->id&amp;groupid=$gid&amp;Itemid=$Itemid\">".$row->subject."</a></h4><p>".$row->post."</p> ".$row->author_name;
	} else {
		$content .= GJ_NO_MESSAGE;
	}
	return $content;
}


function checkImage($avatar) {
	$mosConfig_absolute_path = $_CB_framework->getCfg('absolute_path');
	if (substr($avatar, 0, 7) == 'gallery') {
		$thumbnail = "/images/comprofiler/".$avatar;
	}
	else if ($avatar != '') {
		$thumbnail = "/images/comprofiler/tn".$avatar;
	}
	else {
		$thumbnail = "/components/com_comprofiler/plugin/language/".$fileLang."/images/tnnophoto.jpg";
	}

	// check if thumbnails exists
	if (file_exists($mosConfig_absolute_path.$thumbnail)) {
		// image exists
		$image=$mosConfig_live_site.$thumbnail;
	}
	else {
		// image not found
		$thumbnail="/components/com_comprofiler/plugin/language/".$fileLang."/images/tnnophoto.jpg";

		// check if default image exists in specific language
		if (file_exists($mosConfig_absolute_path.$thumbnail)) {
			$image=$mosConfig_live_site.$thumbnail;
		}
		else {
			$image=$mosConfig_live_site."/components/com_comprofiler/plugin/"
				 ."language/default_language/images/tnnophoto.jpg";
		}
	}
}



?>
